//package GeneticScreen;

//import Person.*;
//import BayesNetwork.*;
//import Pedigree.*;
//import GenExceptions.*;

// this class is abstract representation of a genetic screening test.  It is associated with
// a pedigree (which created it), a person, a test result, and a GeneticSreenDescriptor which 
// describes the properties of this test

abstract public class GeneticScreen {

	abstract public Pedigree getPedigree();
	// effects: Returns the pedigree which created this test

	abstract public Person getPerson();
	// effects: Returns the person this test was performed on

	abstract public String getResult();
	// effects: Returns he observed test result

	abstract public void setResult(String result) throws InvalidValueException, ProbabilityException;
	// effects: Set the observed test result

	abstract public GeneticScreenDescriptor getGeneticScreenDescriptor();
	// effects: Get the genetic screen descriptor describing the properties of this test
}
