//package GeneticScreen;

//import GenExceptions.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*; //Property change stuff
import javax.swing.border.LineBorder;
import java.io.*;

public class GeneticScreenDialog extends JDialog {

	boolean bChanged;

	// constructor
	public GeneticScreenDialog(JFrame f, GeneticScreen inputGs) {
		super(f, "Genetic screen results", true);

		final GeneticScreen gs = inputGs;
		GeneticScreenDescriptor gsd = gs.getGeneticScreenDescriptor();
		JLabel headingLabel = new JLabel(gsd.getName() + " results for " + gs.getPerson().getName());

		final JComboBox resultsComboBox = new JComboBox(gsd.getGenotypes());
		resultsComboBox.setSelectedItem(gs.getResult());

		Object[] array = {headingLabel, resultsComboBox};

        final String btnString1 = "OK";
        final String btnString2 = "Cancel";
        Object[] options = {btnString1, btnString2};

        final JOptionPane optionPane = new JOptionPane(array, 
                                    JOptionPane.PLAIN_MESSAGE,
                                    JOptionPane.YES_NO_OPTION,
                                    null,
                                    options, 
									options[0]);
        setContentPane(optionPane);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
            }
        });

        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();
				if (isVisible() 
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) {
                        //ignore reset
                        return;
                    }

                    // Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(
                            JOptionPane.UNINITIALIZED_VALUE);

                    if (value.equals(btnString1)) {  // the user pushed ok
						bChanged = false;
						String newResult = (String)resultsComboBox.getSelectedItem();
						if (newResult.equals(gs.getResult())) {
							setVisible(false);
							return;
						}
						try {
							gs.setResult(newResult);
							bChanged = true;
						}
						catch(InvalidValueException iie) {
							System.err.println("Unexpected InvalidValueException occured in geneticScreenDialog");
						}
						catch(ProbabilityException pe){
						  System.err.println("Probability exception");
						}
						setVisible(false);
					}
					else { // user clicked cancel
						bChanged = false;
                        setVisible(false);
                    }
                }
            }
        });
	}

	public boolean didGeneticScreenChange() {
		return bChanged;
	}

	
}





		


