//package GeneticScreen;

//import Person.*;
//import BayesNetwork.*;

import javax.swing.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*; //Property change stuff

public class GeneticScreenPickDialog extends JDialog {

	Vector vGSDs;
	String selectedItem;

	public GeneticScreenPickDialog(JFrame f, Vector geneticScreenDescriptors) {
		super(f, "Pick genetic screen to delete from pedigree", true);

		vGSDs = geneticScreenDescriptors;
		selectedItem = null;

		final JComboBox comboBox = new JComboBox();
		Enumeration enumGSDs = geneticScreenDescriptors.elements();
		while (enumGSDs.hasMoreElements()) {
			GeneticScreenDescriptor gsd = (GeneticScreenDescriptor)enumGSDs.nextElement();
			comboBox.addItem(gsd.getName());
		}

		Object[] array = {comboBox};

		final String btnString1 = "OK";
        final String btnString2 = "Cancel";
        Object[] options = {btnString1, btnString2};

        final JOptionPane optionPane = new JOptionPane(array, 
                                    JOptionPane.PLAIN_MESSAGE,
                                    JOptionPane.YES_NO_OPTION,
                                    null,
                                    options, 
									options[0]);

        setContentPane(optionPane);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
            }
        });

        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();
				if (isVisible() 
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) {
                        //ignore reset
                        return;
                    }

					// Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(
                            JOptionPane.UNINITIALIZED_VALUE);

                    if (value.equals(btnString1)) {  // the user pushed ok
						selectedItem = (String)comboBox.getSelectedItem();
						setVisible(false);
					}
					else { // user clicked cancel
                        setVisible(false);
                    }
				}
			}
		});

	}

	public GeneticScreenDescriptor getGeneticScreenDescriptor() {
		if (selectedItem == null)
			return null;
		Enumeration enumGSDs = vGSDs.elements();
		while (enumGSDs.hasMoreElements()) {
			GeneticScreenDescriptor gsd = (GeneticScreenDescriptor)enumGSDs.nextElement();
			if (gsd.getName().equals(selectedItem))
				return gsd;
		}

		return null;
	}
	
}
