//package Disease;

//import Person.*;
//import BayesNetwork.*;

import javax.swing.table.*;
import javax.swing.event.*;  // Added for ChangeEvents
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*; //Property change stuff
import javax.swing.border.LineBorder;
import java.util.Vector;

public class NewDiseaseDialog extends JDialog {

	JFrame frame;
	Disease newDisease;
	Vector vAlleles;			 // this contains all the bad alleles, and the normal allele if the complex alleles
								 // have been set
	boolean bComplexAllelesSet;  // this is used to determine if the complex alleles have been set
								 // they may have been set but the mode is switched to simple disease
	double[] complexMutationRates;
	Vector vComplexDiseaseRaces;
	double[][] dComplexFreqRates;
	double[][] dComplexExpressionRates;


	// constructor
	public NewDiseaseDialog(JFrame f, Disease oldDisease) {
		super(f, "Edit disease", true);

		frame = f;
		newDisease = null;
		vAlleles = new Vector();
		complexMutationRates = null;
		vComplexDiseaseRaces = null;
		dComplexFreqRates = null;
		dComplexExpressionRates = null;

		// create name panel
		JPanel namePanel = new JPanel();
		namePanel.add(new JLabel("Name: "));
		final JTextField nameTextField = new JTextField(10);
		namePanel.add(nameTextField);

		// create locus panel
		JPanel locusPanel = new JPanel();
		ButtonGroup locusButtonGroup = new ButtonGroup();
		final JRadioButton autosomalButton = new JRadioButton("Autosomal locus", true);
		autosomalButton.addActionListener(new ActionListener(){
		    public void actionPerformed(ActionEvent e){
		      int numAlleles = vAlleles.size();
		      if((dComplexExpressionRates != null) && (dComplexExpressionRates[0].length != ((numAlleles*numAlleles+numAlleles)/2))){
			dComplexExpressionRates = null;  // Make sure expression rates for xlinked disease are cleared
		      }
		    }
		  });
		final JRadioButton xlinkedButton = new JRadioButton("X-linked locus", false);
		xlinkedButton.addActionListener(new ActionListener(){
		    public void actionPerformed(ActionEvent e){
		      int numAlleles = vAlleles.size();
		      if((dComplexExpressionRates != null) && (dComplexExpressionRates[0].length != ((numAlleles*numAlleles+3*numAlleles)/2))){
			dComplexExpressionRates = null;  // Make sure expression rates for autosomal disease are cleared
		      }
		    }
		  });
		//xlinkedButton.addActionListener(new ActionListener() {
				//public void actionPerformed(ActionEvent e) {
				  //errorMessage("Sex linked diseases are not currently supported.");
				  //xlinkedButton.setSelected(false);
				  //autosomalButton.setSelected(true);
				//}
		//});
		locusButtonGroup.add(autosomalButton);
		locusButtonGroup.add(xlinkedButton);
		locusPanel.add(autosomalButton);
		locusPanel.add(xlinkedButton);

		// create the buttons and group for type of disease
		ButtonGroup diseaseTypeButtonGroup = new ButtonGroup();
		final JRadioButton simpleDiseaseButton = new JRadioButton("Simple Two Allele Disease", true);
		final JRadioButton complexDiseaseButton = new JRadioButton("Complex Disease", false);
		diseaseTypeButtonGroup.add(simpleDiseaseButton);
		diseaseTypeButtonGroup.add(complexDiseaseButton);
		// functionality for these two buttons is done below


		// create simple disease panel
		JPanel simpleDiseasePanel = new JPanel();
		simpleDiseasePanel.setLayout(new BorderLayout());
		simpleDiseasePanel.add(simpleDiseaseButton, BorderLayout.NORTH);
		JPanel fillerPanel1 = new JPanel();
		fillerPanel1.setPreferredSize(new Dimension(20, 20));
		simpleDiseasePanel.add(fillerPanel1, BorderLayout.WEST);

		JPanel sdInfoPanel = new JPanel();
		sdInfoPanel.setLayout(new BorderLayout());
		JPanel topsdPanel = new JPanel();
		topsdPanel.setLayout(new BorderLayout());
		JPanel bottomsdPanel = new JPanel();
		bottomsdPanel.setLayout(new BorderLayout());

		// create the two allele panel
		final JTextField normalAlleleTextField = new JTextField(3);			
		final JTextField defectiveAlleleTextField = new JTextField(3);
		JPanel allelePairPanel = new JPanel();
		allelePairPanel.add(new JLabel("Normal Allele: "));
		allelePairPanel.add(normalAlleleTextField);
		allelePairPanel.add(new JLabel("Defective Allele: "));
		allelePairPanel.add(defectiveAlleleTextField);
		topsdPanel.add(allelePairPanel, BorderLayout.NORTH);

		// create recessive-dominant panel
		JPanel domrecPanel = new JPanel();
		ButtonGroup domrecButtonGroup = new ButtonGroup();
		final JRadioButton domButton = new JRadioButton("Dominant", true);
		final JRadioButton recButton = new JRadioButton("Recessive", false);
		domrecButtonGroup.add(domButton);
		domrecButtonGroup.add(recButton);
		domrecPanel.add(domButton);
		domrecPanel.add(recButton);
		topsdPanel.add(domrecPanel, BorderLayout.SOUTH);

		// create mutation panel
		JPanel mutationPanel = new JPanel();
		mutationPanel.add(new JLabel("Mutation Rate: "));
		final JTextField mutationRateTextField = new JTextField("0", 5);
		mutationPanel.add(mutationRateTextField);
		bottomsdPanel.add(mutationPanel, BorderLayout.NORTH);

		// create disease freq panel
		JPanel freqPanel = new JPanel();
		freqPanel.add(new JLabel("Disease frequency"));
		final JTextField freqTextField = new JTextField("0.5", 5);  // Default
		freqPanel.add(freqTextField);
		bottomsdPanel.add(freqPanel, BorderLayout.SOUTH);

		sdInfoPanel.add(topsdPanel, BorderLayout.NORTH);
		sdInfoPanel.add(bottomsdPanel, BorderLayout.SOUTH);

		simpleDiseasePanel.add(sdInfoPanel, BorderLayout.EAST);
		simpleDiseasePanel.setBorder(LineBorder.createBlackLineBorder());


		// create complex disease panel
		JPanel complexDiseasePanel = new JPanel();
		bComplexAllelesSet = false;
		complexDiseasePanel.setLayout(new BorderLayout());
		complexDiseasePanel.add(complexDiseaseButton, BorderLayout.NORTH);

		// create info panel
		JPanel cdPanel = new JPanel();
		cdPanel.setLayout(new BorderLayout());

		JPanel topcdPanel = new JPanel();
		topcdPanel.setLayout(new BorderLayout());

		// create normal allele panel
		JPanel normalAllelePanel = new JPanel();
		normalAllelePanel.add(new JLabel("Normal Allele: "));
		final JTextField cdNormalAllele = new JTextField(3);
		normalAllelePanel.add(cdNormalAllele);

		// create allele panel
		JPanel allelePanel = new JPanel();
		allelePanel.setLayout(new BorderLayout());
		JPanel topAllelesPanel = new JPanel();
		final JButton removeAlleleButton = new JButton("Remove Allele");
		final JComboBox allelesComboBox = new JComboBox();
		removeAlleleButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					String sAllele = (String)allelesComboBox.getSelectedItem();
					allelesComboBox.removeItem(sAllele);
					vAlleles.removeElement(sAllele);
					if (allelesComboBox.getItemCount() == 0)
						removeAlleleButton.setEnabled(false);
					//bGeneticScreenChanged=true;
				}
		});
		removeAlleleButton.setEnabled(false);
		topAllelesPanel.add(removeAlleleButton);
		topAllelesPanel.add(allelesComboBox);
		JPanel bottomAllelesPanel = new JPanel();
		final JTextField alleleTextField = new JTextField(10);
		final JButton addAlleleButton = new JButton("Add Allele");
		addAlleleButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					String sAllele = alleleTextField.getText().trim();
					// make sure this string is ok
					if (sAllele.equals(""))
						return;
					if (sAllele.indexOf(" ") != -1) {
						errorMessage("Allele names can not contain spaces.");
						return;
					}
					if (sAllele.indexOf("-") != -1) {
						errorMessage("Allele names can not contain a \"-\" character");
						return;
					}
					if (vAlleles.contains(sAllele)) {
						errorMessage("This allele has already been added");
						return;
					}
					allelesComboBox.addItem(sAllele);
					vAlleles.addElement(sAllele);
					if (allelesComboBox.getItemCount() == 1)
						removeAlleleButton.setEnabled(true);
					alleleTextField.setText("");
					//bGeneticScreenChanged=true;
				}
		});
		bottomAllelesPanel.add(addAlleleButton);
		bottomAllelesPanel.add(alleleTextField);
		allelePanel.add(topAllelesPanel, BorderLayout.NORTH);
		allelePanel.add(bottomAllelesPanel, BorderLayout.SOUTH);


		JPanel toptopcdPanel = new JPanel();
		toptopcdPanel.setLayout(new BorderLayout());
		toptopcdPanel.add(normalAllelePanel, BorderLayout.NORTH);
		toptopcdPanel.add(allelePanel, BorderLayout.SOUTH);
		topcdPanel.add(toptopcdPanel, BorderLayout.NORTH);


		// set and reset alleles
		JPanel resetSetAllelePanel = new JPanel();
		final JButton setAlleleButton = new JButton("Set Alleles");
		final JButton resetAlleleButton = new JButton("Reset Alleles");
		final JButton freqButton = new JButton("Edit frequency table");
		final JButton mutationButton = new JButton("Edit mutation rates");
		final JButton expressionButton = new JButton("Edit expression table");
		setAlleleButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// make sure the normal allele is ok
				String normalAllele = cdNormalAllele.getText().trim();
				if (normalAllele.equals("")) {
					errorMessage("The normal allele must be created");
					return;
				}
				if (normalAllele.indexOf(" ") != -1) {
					errorMessage("The normal allele con not contain spaces");
					return;
				}
				if (normalAllele.indexOf("-") != -1) {
					errorMessage("The normal allele can not contain the \"-\" character");
					return;
				}
				// do we have enough defective alleles?
				if (vAlleles.size() == 0) {
					errorMessage("Defective alleles must be added.");
					return;
				}
				// is this already a defective allele?
				if (vAlleles.contains(normalAllele)) {
					errorMessage("The normal allele has already been added as a defective allele");
					return;
				}

				// disable all the add/remove allele stuff
				removeAlleleButton.setEnabled(false);
				addAlleleButton.setEnabled(false);
				alleleTextField.setEnabled(false);
				cdNormalAllele.setEnabled(false);
				setAlleleButton.setEnabled(false);
				
				// enable buttons
				expressionButton.setEnabled(true);
				freqButton.setEnabled(true);
				mutationButton.setEnabled(true);
				resetAlleleButton.setEnabled(true);

				// add normal allele to the list of alleles
				vAlleles.insertElementAt(normalAllele, 0);

				bComplexAllelesSet = true;
			}
		});
		resetAlleleButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// remove the normal allele
				vAlleles.removeElementAt(0);

				// disable buttons
				expressionButton.setEnabled(false);
				freqButton.setEnabled(false);
				mutationButton.setEnabled(false);
				resetAlleleButton.setEnabled(false);

				//enable buttons
				removeAlleleButton.setEnabled(true);
				addAlleleButton.setEnabled(true);
				alleleTextField.setEnabled(true);
				cdNormalAllele.setEnabled(true);
				setAlleleButton.setEnabled(true);

				bComplexAllelesSet = false;
			}
		});
		setAlleleButton.setEnabled(true);
		resetAlleleButton.setEnabled(false);
		resetSetAllelePanel.add(setAlleleButton);
		resetSetAllelePanel.add(resetAlleleButton);
		topcdPanel.add(resetSetAllelePanel, BorderLayout.SOUTH);

		JPanel bottomcdPanel = new JPanel();
		bottomcdPanel.setLayout(new BorderLayout());

		JPanel cdmutationFreqPanel = new JPanel();
		mutationButton.setEnabled(false);
		mutationButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				MutationRateDialog mrd = new MutationRateDialog(frame, vAlleles, complexMutationRates);
				mrd.setVisible(true);
				if (mrd.mutationRatesChanged())
					complexMutationRates = mrd.getMutationRates();
			}
		});
		freqButton.setEnabled(false);
		freqButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				FreqRateDialog mrd = new FreqRateDialog(frame, vAlleles, vComplexDiseaseRaces, dComplexFreqRates);
				mrd.setVisible(true);
				if (mrd.freqChanged()) {
					vComplexDiseaseRaces = mrd.getRaces();
					dComplexFreqRates = mrd.getFreq();
				}
			}
		});
		cdmutationFreqPanel.add(mutationButton);
		cdmutationFreqPanel.add(freqButton);
		bottomcdPanel.add(cdmutationFreqPanel, BorderLayout.NORTH);

		JPanel cdexpressionPanel = new JPanel();
		expressionButton.setEnabled(false);
		expressionButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				int numAlleles = vAlleles.size();
				// Add code here to distinguish between x-linked and autosomal disease
				String[] sGenotypes;
				if(autosomalButton.isSelected()){
				  sGenotypes = new String[(numAlleles*numAlleles + numAlleles)/2];
				  System.out.println("The number of genotypes is: "+(numAlleles*numAlleles + numAlleles)/2);  // DEBUG
				  int index = 0;
				  for(int x =0; x < numAlleles; x++) {
				    for(int y=x; y < numAlleles; y++, index++) {
						sGenotypes[index] = vAlleles.elementAt(x) + "-" + vAlleles.elementAt(y);
				    }
				  }
				}
				else{ // Disease is Xlinked
				  sGenotypes = new String[(numAlleles*numAlleles+numAlleles)/2 + numAlleles];
				  System.out.println("The number of genotypes is: "+(numAlleles*numAlleles+3*numAlleles)/2);
				  int index = 0;
				  for(int x=0; x<numAlleles;x++){
				    for(int y=x; y<numAlleles;y++, index++){
				      sGenotypes[index]= vAlleles.elementAt(x)+"-"+ vAlleles.elementAt(y);
				    }
				  }
				  for(int x=0; x<numAlleles; x++, index++){
				    sGenotypes[index]=(String) vAlleles.elementAt(x);
				  }
				}
				ExpressionDialog ed = new ExpressionDialog(frame, sGenotypes, dComplexExpressionRates);
				ed.setVisible(true);
				if (ed.expressionChanged())
					dComplexExpressionRates = ed.getExpressionRates();
			}
		});
		cdexpressionPanel.add(expressionButton);
		bottomcdPanel.add(cdexpressionPanel, BorderLayout.SOUTH);
		
		cdPanel.add(topcdPanel, BorderLayout.NORTH);
		cdPanel.add(bottomcdPanel, BorderLayout.SOUTH);


		complexDiseasePanel.add(cdPanel, BorderLayout.SOUTH);
		complexDiseasePanel.setBorder(LineBorder.createBlackLineBorder());

		// functionality for type of disease buttons
		simpleDiseaseButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					normalAlleleTextField.setEnabled(true);
					defectiveAlleleTextField.setEnabled(true);
					domButton.setEnabled(true);
					recButton.setEnabled(true);
					mutationRateTextField.setEnabled(true);
					freqTextField.setEnabled(true);

					cdNormalAllele.setEnabled(false);
					removeAlleleButton.setEnabled(false);
					allelesComboBox.setEnabled(false);
					alleleTextField.setEnabled(false);
					addAlleleButton.setEnabled(false);
					setAlleleButton.setEnabled(false);
					resetAlleleButton.setEnabled(false);
					freqButton.setEnabled(false);
					mutationButton.setEnabled(false);
					expressionButton.setEnabled(false);
				}
		});
		complexDiseaseButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					normalAlleleTextField.setEnabled(false);
					defectiveAlleleTextField.setEnabled(false);
					domButton.setEnabled(false);
					recButton.setEnabled(false);
					mutationRateTextField.setEnabled(false);
					freqTextField.setEnabled(false);

					if (bComplexAllelesSet) {
						resetAlleleButton.setEnabled(true);
						freqButton.setEnabled(true);
						mutationButton.setEnabled(true);
						expressionButton.setEnabled(true);
					}
					else {
						cdNormalAllele.setEnabled(true);
						if (vAlleles.size() > 0)
							removeAlleleButton.setEnabled(true);
						allelesComboBox.setEnabled(true);
						alleleTextField.setEnabled(true);
						addAlleleButton.setEnabled(true);
						setAlleleButton.setEnabled(true);
					}

				}
		});

		// init of settings
		if (oldDisease == null) {
			cdNormalAllele.setEnabled(false);
			removeAlleleButton.setEnabled(false);
			allelesComboBox.setEnabled(false);
			alleleTextField.setEnabled(false);
			addAlleleButton.setEnabled(false);
			setAlleleButton.setEnabled(false);
			resetAlleleButton.setEnabled(false);
			freqButton.setEnabled(false);
			mutationButton.setEnabled(false);
			expressionButton.setEnabled(false);
		}
		else {
			nameTextField.setText(oldDisease.getName());
			if (oldDisease.isSexLinked())
				xlinkedButton.setEnabled(true);
			boolean bIsSimpleDisease = true;
			boolean isDominant = false;
			if (oldDisease.isRaceDependent() || oldDisease.isAgeDependent() || 
			   (oldDisease.getDefectiveAlleles().length > 1))
				bIsSimpleDisease = false;
			if (bIsSimpleDisease) {
				// make sure it really is simple in the fact that it is recessive or dominant
				double[][] expressionRates = oldDisease.getExpressionRates(Person.MALE);
				// since this is a two allele disease, normal normal must be one, and the other two are 1.0 or 0
				if ((expressionRates[0][0] != 0) || (expressionRates[0][1] != 0 && expressionRates[0][1] != 1) ||
					(expressionRates[0][2] != 1))
					bIsSimpleDisease = false;
				if (expressionRates[0][1] == 1)
					isDominant = true;
				else
					isDominant = false;
			}

			if (bIsSimpleDisease) {
				normalAlleleTextField.setText(oldDisease.getNormalAllele());
				defectiveAlleleTextField.setText(oldDisease.getDefectiveAlleles()[0]);
				if (!isDominant)
					recButton.setEnabled(true);
				if (oldDisease.hasMutationRate()) {
					double[] mutationRates = oldDisease.getMutationRates();
					mutationRateTextField.setText(Double.toString(mutationRates[0]));
				}
				double[][] freqRates = oldDisease.getFrequencyRates();
				if (isDominant)
					freqTextField.setText(Double.toString(freqRates[0][1]));
				else
					freqTextField.setText(Double.toString(freqRates[0][1] * freqRates[0][1]));

				cdNormalAllele.setEnabled(false);
				removeAlleleButton.setEnabled(false);
				allelesComboBox.setEnabled(false);
				alleleTextField.setEnabled(false);
				addAlleleButton.setEnabled(false);
				setAlleleButton.setEnabled(false);
				resetAlleleButton.setEnabled(false);
				freqButton.setEnabled(false);
				mutationButton.setEnabled(false);
				expressionButton.setEnabled(false);
			}
			else {
				cdNormalAllele.setText(oldDisease.getNormalAllele());
				bComplexAllelesSet = true;
				removeAlleleButton.setEnabled(false);
				String[] badAlleles = oldDisease.getDefectiveAlleles();
				for(int x = 0; x < badAlleles.length; x++) {
					allelesComboBox.addItem(badAlleles[x]);
					vAlleles.addElement(badAlleles[x]);
				}
				vAlleles.insertElementAt(oldDisease.getNormalAllele(), 0);
				addAlleleButton.setEnabled(false);
				setAlleleButton.setEnabled(false);
				resetAlleleButton.setEnabled(true);
				freqButton.setEnabled(true);
				mutationButton.setEnabled(true);
				expressionButton.setEnabled(true);
				complexMutationRates = oldDisease.getMutationRates();
				String[] races = oldDisease.getRaces();
				vComplexDiseaseRaces = new Vector();
				for(int x = 0; x < races.length; x++)
					vComplexDiseaseRaces.addElement(races[x]);
				dComplexFreqRates = oldDisease.getFrequencyRates();
				dComplexExpressionRates = oldDisease.getExpressionRates(Person.UNKNOWN);

				normalAlleleTextField.setEnabled(false);
				defectiveAlleleTextField.setEnabled(false);
				domButton.setEnabled(false);
				recButton.setEnabled(false);
				mutationRateTextField.setEnabled(false);
				freqTextField.setEnabled(false);
			}


		}

		Object[] array = {namePanel, locusPanel, simpleDiseasePanel, complexDiseasePanel};

        final String btnString1 = "OK";
        final String btnString2 = "Cancel";
        Object[] options = {btnString1, btnString2};

        final JOptionPane optionPane = new JOptionPane(array, 
                                    JOptionPane.PLAIN_MESSAGE,
                                    JOptionPane.YES_NO_OPTION,
                                    null,
                                    options, 
									options[0]);
        setContentPane(optionPane);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
            }
        });

        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();
				if (isVisible() 
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) {
                        //ignore reset
                        return;
                    }

                    // Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(
                            JOptionPane.UNINITIALIZED_VALUE);

                    if (value.equals(btnString1)) {  // the user pushed ok
						// get the name
						String name = nameTextField.getText().trim();
						if (name.equals("")) {
							errorMessage("Enter a name for the disease");
							return;
						}

						// get the locus type
						// try this for now.
						boolean autosomal;
						if (autosomalButton.isSelected()){
						  autosomal = true;
						}
						else {
						  autosomal = false;
						}
						// is it a simple diseas or a complex one
						if (simpleDiseaseButton.isSelected()) {
							String normalAllele = normalAlleleTextField.getText().trim();
							String badAllele = defectiveAlleleTextField.getText().trim();
							Vector vRaces = null;
							if (normalAllele.equals("")) {
								errorMessage("Enter a normal allele");
								return;
							}
							if (badAllele.equals("")) {
								errorMessage("Enter a defective allele");
								return;
							}
							if (badAllele.equals(normalAllele)) {
								errorMessage("Defective allele and normal allele must be distinct");
								return;
							}

							boolean bDominant;
							if (domButton.isSelected())
								bDominant = true;
							else
								bDominant = false;

							double mutationRate;
							try {
								mutationRate = Double.valueOf(mutationRateTextField.getText()).doubleValue();
								if ((mutationRate > 1.0) || (mutationRate < 0))
									throw new NumberFormatException();
							}
							catch(NumberFormatException nfe) {
								errorMessage("Enter a valid number less than one for the mutation rate.");
								return;
							}

							double diseaseFreq;
							try {
							  diseaseFreq = Double.valueOf(freqTextField.getText()).doubleValue();
							  if ((diseaseFreq > 1.0) || (diseaseFreq < 0))
							    throw new NumberFormatException();
							  
							}
							catch(NumberFormatException nfe) {
								errorMessage("Enter a valid number less than one for the disease frequency.");
								return;
							}

							// create the new disease
							String[] badAlleles = {badAllele};
							double[] mutationRates = {mutationRate};
							if (mutationRate == 0)
								mutationRates = null;

							NewAutosomalDisease ad;
							if(autosomal){
							if (bDominant) {
								double[][] expressionRates = {{0, 1, 1}};
								// for dominant, freq = freq of defective allele ... think about it
								double normalFreq = 1 - diseaseFreq;
								double[][] freqRates = {{normalFreq, diseaseFreq}};
								ad = new NewAutosomalDisease(name, normalAllele, badAlleles, mutationRates, 
									expressionRates, vRaces, freqRates);
							}
							else{  // not dominant
								double[][] expressionRates = {{0, 0, 1}};
								// for recessive, freq = square of defective allele freq
								double defectiveFreq = java.lang.Math.sqrt(diseaseFreq);
								double normalFreq = 1 - defectiveFreq;
								double[][] freqRates = {{normalFreq, defectiveFreq}};
								ad = new NewAutosomalDisease(name, normalAllele, badAlleles, mutationRates,
									expressionRates, vRaces, freqRates);
							}

							newDisease = ad;
							
							setVisible(false);
							return;
							}
						else if(!autosomal){
						  NewXlinkedDisease xd;
						  String[] alleles = {normalAllele, badAllele};
						  if (bDominant){
						    double[][] expressionRates = {{0, 1, 1, 0, 1}};  // diseased allele always listed after normal allele
						    double normalFreq = 1-diseaseFreq;  // diseaseAllele^2-diseaseAllele(1-diseaseAllele) = diseaseFreq
						    double[][] freqRates = {{normalFreq, diseaseFreq}};
						    xd = new NewXlinkedDisease(name, normalAllele, badAlleles, mutationRates,
									    expressionRates, vRaces, freqRates);
						  }
						  else{
						    double[][] expressionRates = {{0, 0, 1, 0, 1}};
						    double defectiveFreq = java.lang.Math.sqrt(diseaseFreq);
						    double normalFreq = 1 - defectiveFreq;
						    double[][] freqRates = {{normalFreq, defectiveFreq}};
						    xd = new NewXlinkedDisease(name, normalAllele, badAlleles, mutationRates,
									       expressionRates, vRaces, freqRates);
						  }
							newDisease = xd;
							setVisible(false);
							return;
						}
						}
						else {  // Complex disease

							if (!bComplexAllelesSet) {
								errorMessage("Select and set alleles.");
								return;
							}
							double[] mutationRates = complexMutationRates; // this can be null for no mutations
							Vector vRaces = vComplexDiseaseRaces; // this can be null
							if(vComplexDiseaseRaces.isEmpty()){
							  vRaces = null;
							}
							
							double[][] freqRates = dComplexFreqRates;  // this must be set
							if (freqRates == null) {
								errorMessage("Select frequency rates for alleles");
								return;
							}
							double[][] expressionRates = dComplexExpressionRates;  // this must be set
							if (expressionRates == null) {
								errorMessage("Select expression rates of disease");
								return;
							}

							String normalAllele = (String)vAlleles.elementAt(0);
							vAlleles.removeElementAt(0);
							String[] badAlleles = new String[vAlleles.size()];
							vAlleles.copyInto(badAlleles);
							vAlleles.insertElementAt(normalAllele, 0); // set the vAllele back to original shape
							if(autosomal){
							newDisease = new NewAutosomalDisease(name, normalAllele, badAlleles, mutationRates,
								expressionRates, vRaces, freqRates);
							// DEBUG
							System.out.println("Created New Autosomal Disease");
							}
							else{
							  newDisease = new NewXlinkedDisease(name, normalAllele, badAlleles, mutationRates, expressionRates, vRaces, freqRates);
							  System.out.println("Created New X Linked Disease");
							}
							setVisible(false);
							return;
						}

					}
					else { // user clicked cancel
                        setVisible(false);
                    }
                }
            }
        });

		this.pack();
	}

	private void errorMessage(String eMessage) {
		JOptionPane.showMessageDialog(this, eMessage,
					"Disease Edit Error", JOptionPane.INFORMATION_MESSAGE);
	}

	public Disease getNewDisease() {
		return newDisease;
	}


}


class FreqRateDialog extends JDialog {

	int indexOfOldSelection;
	boolean bRacesSelected;
	int numAlleles;
	double[][] probs;
	Vector vRaces;
	boolean bFreqChanged;

	public FreqRateDialog(JFrame fOwner, Vector vsAlleles, Vector vsRaces, double[][] iprobs) {
	// requires: vaRaces and iprobs can be null.  iprobs must be the right size for the race and allele vectors
	// effects:  vsAlleles is a vector of string of all the alleles
	//			 vsRaces is a vector of all the races.  If this disease is race independent,
	//			 then this should be set to null
	//			 iprobs is the frequencies where each row is for a different race, and each column is
	//			 rate for that index allele in the vsAlleles vector.  If this is totally new, then iprobs can
	//			 be null

		super(fOwner, "Edit allele frequency table", true);

		numAlleles = vsAlleles.size();
		probs = iprobs;
		if (probs == null)
			probs = new double[1][numAlleles];
		if (vsRaces == null)
			vsRaces = new Vector();
		vRaces = vsRaces;

		final JButton removeRaceButton = new JButton("Remove Allele");
		final JComboBox raceComboBox = new JComboBox(vRaces);
		final JTextField raceTextField = new JTextField(10);
		final JButton addRaceButton = new JButton("Add Race");
		final JButton setRaceButton = new JButton("Set races");
		final JButton resetRaceButton = new JButton("Change races");
		final JTextField[] probFields= new JTextField[vsAlleles.size()];

		final JCheckBox raceDependentCheckBox = new JCheckBox("Race dependent population frequency");
		raceDependentCheckBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				bRacesSelected = false;
				JCheckBox source = (JCheckBox)e.getSource();
				if (source.isSelected()) {
					// enable all the buttons
					setRaceButton.setEnabled(true);
					addRaceButton.setEnabled(true);
					raceComboBox.setEnabled(true);
					raceTextField.setEnabled(true);
					if (vRaces.size() != 0)
						removeRaceButton.setEnabled(true);
					bRacesSelected = false;
					
					if (probFields[0].isEnabled()) {
						for(int x = 0;x < numAlleles; x++)
							probFields[x].setEnabled(false);	
					}
				}
				else {
					probs = new double[1][numAlleles];
					if (setRaceButton.isEnabled()) {
						// need to disable all these buttons and enable prob table
						addRaceButton.setEnabled(false);
						removeRaceButton.setEnabled(false);
						raceComboBox.setEnabled(false);
						raceTextField.setEnabled(false);
						setRaceButton.setEnabled(false);

						if (!probFields[0].isEnabled()) {
							for(int x = 0;x < numAlleles; x++)
								probFields[x].setEnabled(true);	
						}
					}
					else {
						resetRaceButton.setEnabled(false);
					}
				}
			}
		});

		JPanel racePanel = new JPanel();
		racePanel.setLayout(new BorderLayout());
		JPanel topRacePanel = new JPanel();
		JPanel bottomRacePanel = new JPanel();
		removeRaceButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					String sRace = (String)raceComboBox.getSelectedItem();
					raceComboBox.removeItem(sRace);
					vRaces.removeElement(sRace);
					if (raceComboBox.getItemCount() == 0)
						removeRaceButton.setEnabled(false);
				}
		});
		removeRaceButton.setEnabled(false);
		bottomRacePanel.add(removeRaceButton);
		bottomRacePanel.add(raceComboBox);
		
		addRaceButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					String sRace = raceTextField.getText().trim();
					// make sure this string is ok
					if (sRace.equals(""))
						return;
					if (sRace.indexOf(" ") != -1) {
						errorMessage("Race names can not contain spaces.");
						return;
					}
					if (vRaces.contains(sRace)) {
						errorMessage("This race has already been added");
						return;
					}
					raceComboBox.addItem(sRace);
					vRaces.addElement(sRace);
					if (raceComboBox.getItemCount() == 1)
						removeRaceButton.setEnabled(true);
					raceTextField.setText("");
				}
		});
		topRacePanel.add(addRaceButton);
		topRacePanel.add(raceTextField);
		racePanel.add(topRacePanel, BorderLayout.NORTH);
		racePanel.add(bottomRacePanel, BorderLayout.SOUTH);

		JPanel raceButtonPanel = new JPanel();
		raceButtonPanel.add(setRaceButton);
		raceButtonPanel.add(resetRaceButton);
		resetRaceButton.setEnabled(false);
		setRaceButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (vRaces.size() < 2) {
					errorMessage("At least two races must be created");
					return;
				}

				double[][] newProbs = new double[vRaces.size()][numAlleles];
				if (probs != null) {
					// copy as much of the old values as possible
					for(int x = 0; (x < probs.length) && (x < newProbs.length); x++) {
						for(int y =0; y < numAlleles; y++)
							newProbs[x][y] = probs[x][y];
					}
				}
				probs = newProbs;
				// init the textfields
				for (int x=0; x < numAlleles; x++) {
					probFields[x].setText(Double.toString(probs[0][x]));
					probFields[x].setEnabled(true);
				}                                                                                                                                                                                                                                                                                           

				addRaceButton.setEnabled(false);
				removeRaceButton.setEnabled(false);
				raceTextField.setEnabled(false);
				resetRaceButton.setEnabled(true);
				setRaceButton.setEnabled(false);
				bRacesSelected = true;
			}
		});
		resetRaceButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// disable all the textfield stuff
				for(int x = 0;x < numAlleles; x++)
					probFields[x].setEnabled(false);

				// renable all the edit race stuff
				addRaceButton.setEnabled(true);
				if (vRaces.size() != 0)
					removeRaceButton.setEnabled(true);
				raceTextField.setEnabled(true);

				resetRaceButton.setEnabled(false);
				setRaceButton.setEnabled(true);
				bRacesSelected = false;
			}
		});

		raceComboBox.addActionListener(new ActionListener() {
			 public void actionPerformed(ActionEvent e) {
				 if (bRacesSelected) {
					try {
					// save to old values
					double dSum = 0;
					for (int x = 0; x < numAlleles; x++)
						dSum += probs[indexOfOldSelection][x] = Double.valueOf(probFields[x].getText()).doubleValue();
					// make sure the row sums to 1.0
					if (java.lang.Math.abs(dSum - 1.0) > .1) {
						errorMessage("The probabilities for this row must sum to 1.0");
						raceComboBox.setSelectedIndex(indexOfOldSelection);
						return;
					}

					// set up the new row
					indexOfOldSelection = raceComboBox.getSelectedIndex();
					for (int x=0; x < numAlleles; x++)
						probFields[x].setText(Double.toString(probs[indexOfOldSelection][x]));
					}
					catch(NumberFormatException nfe) {
						errorMessage("Please enter valid probabilities");
					}
				 }
			 }
        });
		indexOfOldSelection = 0;

		JPanel totalRacePanel = new JPanel();
		totalRacePanel.setLayout(new BorderLayout());
		totalRacePanel.add(racePanel, BorderLayout.NORTH);
		totalRacePanel.add(raceButtonPanel, BorderLayout.SOUTH);
		totalRacePanel.setBorder(LineBorder.createBlackLineBorder());
	
		JPanel probPanel = new JPanel();
		probPanel.setLayout(new BorderLayout());
		probPanel.add(new JLabel("Probabilities", JLabel.CENTER), BorderLayout.WEST);
		
	
		JPanel probEntryPanel = new JPanel();		
		for (int x=0; x < numAlleles; x++) {
			JPanel panel = new JPanel();
			panel.setLayout(new BorderLayout());
			panel.add(new JLabel((String)vsAlleles.elementAt(x), JLabel.CENTER), BorderLayout.NORTH);
			probFields[x] = new JTextField(Double.toString(probs[0][x]), 5);
			panel.add(probFields[x], BorderLayout.SOUTH);
			probEntryPanel.add(panel);
		}
		probPanel.add(probEntryPanel, BorderLayout.CENTER);

		Object[] array = {raceDependentCheckBox, totalRacePanel, probPanel};

        final String btnString1 = "OK";
        final String btnString2 = "Cancel";
        Object[] options = {btnString1, btnString2};

        final JOptionPane optionPane = new JOptionPane(array, 
                                    JOptionPane.PLAIN_MESSAGE,
                                    JOptionPane.YES_NO_OPTION,
                                    null,
                                    options, 
									options[0]);
        setContentPane(optionPane);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
            }
        });

        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();
				if (isVisible() 
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) {
                        //ignore reset
                        return;
                    }

                    // Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(
                            JOptionPane.UNINITIALIZED_VALUE);

                    if (value.equals(btnString1)) {  // the user pushed ok
						// save the current row of probs
						double dSum = 0;
						for (int x = 0; x < numAlleles; x++)
							dSum += probs[indexOfOldSelection][x] = Double.valueOf(probFields[x].getText()).doubleValue();
						// make sure the row sums to 1.0
						if (java.lang.Math.abs(dSum - 1.0) > .1) {  // Maybe the margin should be smaller?
							errorMessage("The probabilities for this row must sum to 1.0");
							return;
						}

						// if this is not a race specific one, clear out the race vector
						if (!raceDependentCheckBox.isSelected())
							vRaces.removeAllElements();
						bFreqChanged = true;
						setVisible(false);
					}
					else { // user clicked cancel
						bFreqChanged = false;
                        setVisible(false);
                    }
                }
            }
        });

		//  init the thing
		if (vRaces.size() == 0) {
			addRaceButton.setEnabled(false);
			raceComboBox.setEnabled(false);
			raceTextField.setEnabled(false);
		}
		else {
			// should be ok
		}



		pack();
	}

	private void errorMessage(String eMessage) {
		JOptionPane.showMessageDialog(this, eMessage,
					"Disease Edit Error", JOptionPane.INFORMATION_MESSAGE);
	}

	public Vector getRaces() {
	  // System.out.println(vRaces);  // DEBUG
		return vRaces;
	}

	public double[][] getFreq() {
		return probs;
	}

	public boolean freqChanged() {
		return bFreqChanged;
	}
}


class ExpressionDialog extends JDialog {

	final int numAgeGroups = 9;
	double probs[][];
	boolean bChanged;
	
	public ExpressionDialog(JFrame f, String[] sGenotypes, double[][] iProbs) {
		super(f, "Edit expression table", true);

		final int numGenotypes = sGenotypes.length;

		if ((iProbs == null) || (iProbs.length == 1)) {
		  // probs = new double[numAgeGroups][sGenotypes.length];
		   probs = new double[1][sGenotypes.length];
			if (iProbs != null) {
				for (int x = 0; x < sGenotypes.length; x++)
					probs[0][x] = iProbs[0][x];
			}
		}
		else
		  probs = iProbs;


		final MyTableModel mtm = new MyTableModel(f, sGenotypes, probs);
		final JTable myTable = new JTable(mtm);
		myTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		final int firstWidth = 60;
		final int otherWidth = 45;
		myTable.setPreferredScrollableViewportSize(new Dimension(firstWidth+numAgeGroups*otherWidth + 25, 150));
		myTable.getColumnModel().getColumn(0).setMinWidth(firstWidth);
		

		final JCheckBox ageDepCheckBox = new JCheckBox("Age dependent expression");
		ageDepCheckBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				boolean bSelected = ((JCheckBox)e.getSource()).isSelected();
				mtm.updateAgeDependency(bSelected);
				TableColumnModel tcm = myTable.getColumnModel();
				// System.out.println("Readjusting columns."); // DEBUG
				tcm.getColumn(0).setPreferredWidth(firstWidth);
				if (bSelected) {					
					for (int x = 1; x < tcm.getColumnCount(); x++)
						tcm.getColumn(x).setMaxWidth(otherWidth);
					// System.out.println("Columns successfully changed.");  //DEBUG
				}
			}
		});

		final JScrollPane scrollPane = new JScrollPane(myTable);

		Object[] array = {ageDepCheckBox, scrollPane};

        final String btnString1 = "OK";
        final String btnString2 = "Cancel";
        Object[] options = {btnString1, btnString2};

        final JOptionPane optionPane = new JOptionPane(array, 
                                    JOptionPane.PLAIN_MESSAGE,
                                    JOptionPane.YES_NO_OPTION,
                                    null,
                                    options, 
									options[0]);
        setContentPane(optionPane);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
            }
        });

        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();
				if (isVisible() 
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) {
                        //ignore reset
                        return;
                    }

                    // Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(
                            JOptionPane.UNINITIALIZED_VALUE);

                    if (value.equals(btnString1)) {  // the user pushed ok
		      // Hack because the last value is not registered by the program
		      ChangeEvent ce = new ChangeEvent(mtm);
			myTable.editingStopped(ce);
			// save the current row of probs
						if (!ageDepCheckBox.isSelected()) {
							// change probs to a one dimensional array
							double[][] tempProbs = new double[1][numGenotypes];
							for(int x = 0; x < numGenotypes; x++)
								tempProbs[0][x] = probs[0][x];
							probs = tempProbs;
						}
						bChanged = true;
						setVisible(false);
					}
					else { // user clicked cancel
						bChanged = false;
                        setVisible(false);
                    }
                }
            }
        });

		pack();
	}

	public boolean expressionChanged() {
			return bChanged;
	}

	public double[][] getExpressionRates() {
			return probs;
	}


	class MyTableModel extends AbstractTableModel {
	  final String[] columnAgeRanges = {"Genotypes", "0-9", 
									   "10-19",
                                      "20-29",
                                      "30-39",
                                      "40-49", "50-59", "60-69", "70-79", "80-89"};
	  final String[] columnNoAge = {"Genotypes", "Affected Probability"};
	  String[] columnNames;
	  String[] rowNames;
	  double[][] probs;
	  JFrame frame;

	  public MyTableModel(JFrame f, String[] genotypes, double[][] probs) {
			frame = f;
			rowNames = genotypes;
			this.probs = probs;
			if (probs.length > 1)
				columnNames = columnAgeRanges;
			else
				columnNames = columnNoAge;
		}

		public void updateAgeDependency(boolean bAgeDep) {
		  if (bAgeDep){
				columnNames = columnAgeRanges;
				probs = new double[columnAgeRanges.length][rowNames.length];
		  }
		  else{
				columnNames = columnNoAge;
				probs = new double[1][rowNames.length];
		  }
			fireTableStructureChanged();
			System.out.println("Table Structure Changed.");
		}

        public int getColumnCount() {
            return columnNames.length;
        }
        
        public int getRowCount() {
            return rowNames.length;
        }

        public String getColumnName(int col) {
            return columnNames[col];
        }

        public Object getValueAt(int row, int col) {
	  if (col == 0){
	    return rowNames[row];
	  }
	  else{
	    return new Double(probs[col-1][row]);
	  }
	}

        
        public boolean isCellEditable(int row, int col) {
            if (col == 0)
                return false;
	    else
                return true;
        }

    
        public void setValueAt(Object value, int row, int col) {
            try {
					double tempValue = Double.valueOf((String)value).doubleValue();
					if (tempValue < 0) {
						JOptionPane.showMessageDialog(frame,
                        "Values must be positive.");
						return;
					}
					if (tempValue > 1.0) {
						JOptionPane.showMessageDialog(frame,
                        "Values must be less than or equal to one.");
						return;
					}
                    probs[col-1][row] = tempValue;
                    fireTableCellUpdated(row, col);
                } catch (NumberFormatException e) {
                    JOptionPane.showMessageDialog(frame,
                        "Values must be decimal numbers.");
                }
        }
    }
}



class MutationRateDialog extends JDialog {

	double[] rates;
	boolean bChanged;
	boolean bMutationRate;
	JFrame frame;
	
	public MutationRateDialog(JFrame f, Vector vMutationAlleles, double[] mRates) {
		// requires: only mRates can be null.  mRates is not null, must be of the same size of vMutationAlleles
		//			 and contain only non negative values that sum to less than one
		// effects:  If mRates is null, then the dialog is created with no mutation rate.  Else
		//			 the rates in mRates is used.  vMutationAlleles are the alleles that the normal
		//			 Allele can mutate to
		super(f, "Edit mutation rates", true);

		frame = f;
		final int numMutationAlleles = vMutationAlleles.size()-1;
		String normalAllele = (String)vMutationAlleles.elementAt(0);

		if (mRates != null) {
		  bMutationRate = true;
		}
		else {
		  bMutationRate = false;
			mRates = new double[numMutationAlleles];
		}

		rates = mRates;

		final MyTableModel mtm = new MyTableModel(f, vMutationAlleles, rates);
		final JTable myTable = new JTable(mtm);
		myTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		final JScrollPane scrollPane = new JScrollPane(myTable);

		JLabel titleLabel = new JLabel("Mutation rates from normal allele, " + normalAllele + ", to defective alleles");

		Object[] array = {titleLabel, scrollPane};

        final String btnString1 = "OK";
        final String btnString2 = "Cancel";
        Object[] options = {btnString1, btnString2};

        final JOptionPane optionPane = new JOptionPane(array, 
                                    JOptionPane.PLAIN_MESSAGE,
                                    JOptionPane.YES_NO_OPTION,
                                    null,
                                    options, 
									options[0]);
        setContentPane(optionPane);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
            }
        });

        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();
				if (isVisible() 
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) {
                        //ignore reset
                        return;
                    }

                    // Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(
                            JOptionPane.UNINITIALIZED_VALUE);
		    
                    if (value.equals(btnString1)) {  // the user pushed ok
		      
			// A little hack because the program doesn't register the last value entered.
			ChangeEvent ce = new ChangeEvent(mtm);
			myTable.editingStopped(ce);

			if(mtm.tableChange()){
			// make sure rows sum to less than one
			double dSum = 0;
							for (int x = 0; x < numMutationAlleles; x++)
							  dSum += rates[x];
							// make sure the row sums to 1.0
							if (dSum > 1.0) {
							  JOptionPane.showMessageDialog(frame,
											      "The sum of the mutation rates must be less than one");
								return;
							}
							bChanged = true;
							bMutationRate = true;
		      }
		      else {
			// rates = null;
			bChanged = false;
			//bMutationRate = false;
		      }
		      setVisible(false);
		    }
		    else { // user clicked cancel
		      bChanged = false;
		      rates = null; 
		      setVisible(false);
                    }
                }
            }
        });

		pack();
	}

	public boolean mutationRatesChanged() {
			return bChanged;
	}

	public double[] getMutationRates() {
			return rates;
	}

	public boolean supportsMutationRates() {
		return bMutationRate;
	}

	class MyTableModel extends AbstractTableModel {
		Vector mAlleles;
        double[] mRates;
		JFrame frame;
	  boolean tableChanged = false;

		public MyTableModel(JFrame f, Vector vmAlleles, double[] rates) {
			frame = f;
			mAlleles = vmAlleles;
			mRates = rates;
		}

	  public boolean tableChange(){
	    return tableChanged;
	  }
	  
        public int getColumnCount() {
            return mAlleles.size() - 1;
        }
        
        public int getRowCount() {
            return 1;
        }

        public String getColumnName(int col) {
            return (String)mAlleles.elementAt(col+1);
        }

        public Object getValueAt(int row, int col) {
			return new Double(mRates[col]);
        }

        
        public boolean isCellEditable(int row, int col) {
            return true;
        }

    
        public void setValueAt(Object value, int row, int col) {
	  try {
					double tempValue = Double.valueOf(value.toString()).doubleValue();
					if (tempValue < 0) {
						JOptionPane.showMessageDialog(frame,
                        "Values must be positive.");
						return;
					}
					if (tempValue >= 1.0) {
						JOptionPane.showMessageDialog(frame,
                        "Values must be less than one.");
						return;
					}
					mRates[col] = tempValue;  // Allows for only one normal allele
					System.out.println("Mutation rate set to: "+tempValue);
		    tableChanged = true;
                    fireTableCellUpdated(row, col);
                } catch (NumberFormatException e) {
                    JOptionPane.showMessageDialog(frame,
                        "Values must be decimal numbers.");
                }
        }
    }
}








