//package PedigreeCanvas;

//import Pedigree.*;

// a child line is a pedcanline that connected a child to his parent's marriage line.

import java.util.*;

public class PedCanChildLine extends PedCanLine {

	PedCanPerson child;
	PedCanMarriageLine marriageLine;

	public PedCanChildLine(PedCanPerson child, PedCanMarriageLine mLine, int lineWidth) {
	// requires: child and mLine are not null.  This object does not checking for loops, legality, etc.
	// effects:  Creates a child line between child and his parents marriage line with width lineWidth
		super(PedCanLine.CHILD, lineWidth);

		this.child = child;
		marriageLine = mLine;
	}

	public PedCanPerson getChild() {
		return child;
	}

	public PedCanMarriageLine getMarriageLine() {
		return marriageLine;
	}

	// return a string of the format : ChildLine <childID> <parentID> <parentID>
	public String toString() {
		Enumeration enumCouple = marriageLine.getCouple();
		PedCanPerson parent1 = (PedCanPerson)enumCouple.nextElement();
		PedCanPerson parent2 = (PedCanPerson)enumCouple.nextElement();
		return "ChildLine " + child.getPerson().getID() + " " + parent1.getPerson().getID() +
			    " " + parent2.getPerson().getID();
	}
}
