//package PedigreeCanvas;

//import Pedigree.*;
//import GeneticScreen.*;

import java.awt.*;

public class PedCanGeneticScreen {

	// local state
	GeneticScreen gsTest;
	PedCanTestLine pcTLine;
	Point location;
	int width;

	public PedCanGeneticScreen(GeneticScreen test, PedCanPerson pcPerson, Point location, int width, int lineWidth) {
		gsTest = test;
		pcTLine = new PedCanTestLine(this, pcPerson, lineWidth);;
		this.location = location;
		this.width = width;
	}

	public Point getLocation() {
		return location;
	}

	public void setLocation(Point pt) {
		location = pt;
	}

	public PedCanTestLine getPedCanTestLine() {
		return pcTLine;
	}

	public GeneticScreen getGeneticScreen() {
		return gsTest;
	}

	public void paint(Graphics g) {
		g.fillOval(location.x, location.y, width - 1, width - 1);
		// draw the name too
		FontMetrics fm = g.getFontMetrics();
		int nameWidth = fm.stringWidth(gsTest.getGeneticScreenDescriptor().getName());
		g.drawString(gsTest.getGeneticScreenDescriptor().getName(),
			location.x + ((width - nameWidth)/2),
			location.y + width + fm.getHeight());
	}

	public boolean isOn(int x, int y) {
			Point hitPoint = new Point(x,y);
			Point center = new Point(location.x + width /2, location.y + width / 2);
			// get the distance
			double PX = hitPoint.x - center.x;
			double PY = hitPoint.y - center.y;
			
			if (Math.sqrt(PX * PX + PY * PY) > width / 2)
				return false;
			else return true;
	}

}
