import java.util.*;

//import BayesNetwork.*;
//import GenExceptions.*;
//import Disease.*;
//import Pedigree.*;
//import Person.*;

public class test {

public static void main(String argv[]) {
	//testPedigreeClass();
	testBayesNet();
}

public static void testBayesNet() {
	int i = 0;
	BayesNetwork bn = new GNUJavaBayesNet(); 

	
	// cases with createNode and removeNode- normal and invalid creations
	String[] values1 = {"a", "b", "c"};
	double[] probs1 = {.33, .33, .33};
	String[] values2 = {"d", "e", "f", "g"};
	double[] probs2 = {.25, .25, .25, .25};

	try {
		BayesNetworkNode bnn1 = bn.createNode(values1, probs1);
		BayesNetworkNode bnn2 = bn.createNode(values2, probs2);

		//now lets make sure that we can get these nodes back
		Enumeration enumNodes = bn.getNodes();
		
		boolean sawZeroNode = false;
		boolean sawOneNode = false;
		for (int k=0; k < 2; k++) {
			BayesNetworkNode bnnTestNode;
			checkIfTrue(enumNodes.hasMoreElements(), i++, "getnodes has something");
			if (!enumNodes.hasMoreElements())
				break;
			bnnTestNode = (BayesNetworkNode)enumNodes.nextElement();
			if (bnnTestNode.getUniqueID() == 0) {
				if (sawZeroNode)
					checkIfTrue(false, i++, "saw zero node twice");
				sawZeroNode =true;
				compareBayesNodes(i++, "zero node", bnnTestNode, values1, probs1);
			}
			else {
				if (sawOneNode)
					checkIfTrue(false, i++, "saw one node twice");
				sawOneNode =true;
				compareBayesNodes(i++, "one node", bnnTestNode, values2, probs2);
			}
		}

				
		// lets do a normal remove
		bn.removeNode(bnn1);
		enumNodes = bn.getNodes();
		checkIfTrue(enumNodes.hasMoreElements(), i++, "getnodes reomve has elements");
		if (enumNodes.hasMoreElements())
			compareBayesNodes(i++, "removed one compare", (BayesNetworkNode)enumNodes.nextElement(), values2, probs2);
		checkIfTrue(!enumNodes.hasMoreElements(), i++, "Remove one element");

		// lets add bnn1 back, and remove it twice
		bnn1 = bn.createNode(values1, probs1);
		enumNodes = bn.getNodes();
		
		sawZeroNode = false;
		sawOneNode = false;
		for (int k=0; k < 2; k++) {
			BayesNetworkNode bnnTestNode;
			checkIfTrue(enumNodes.hasMoreElements(), i++, "getnodes has something");
			if (!enumNodes.hasMoreElements())
				break;
			bnnTestNode = (BayesNetworkNode)enumNodes.nextElement();
			if (bnnTestNode.getUniqueID() == 0) {
				if (sawZeroNode)
					checkIfTrue(false, i++, "saw zero node twice");
				sawZeroNode =true;
				compareBayesNodes(i++, "zero node", bnnTestNode, values1, probs1);
			}
			else {
				if (sawOneNode)
					checkIfTrue(false, i++, "saw one node twice");
				sawOneNode =true;
				compareBayesNodes(i++, "one node", bnnTestNode, values2, probs2);
			}
		}

		// now remove it twice
		bn.removeNode(bnn1);
		bn.removeNode(bnn1);
		enumNodes = bn.getNodes();
		checkIfTrue(enumNodes.hasMoreElements(), i++, "getnodes reomve2 has elements");
		if (enumNodes.hasMoreElements())
			compareBayesNodes(i++, "removed2 one compare", (BayesNetworkNode)enumNodes.nextElement(), values2, probs2);
		checkIfTrue(!enumNodes.hasMoreElements(), i++, "Remove2 one element");


		// lets remove everything
		bn.removeNode(bnn2);
		enumNodes= bn.getNodes();
		checkIfTrue(!enumNodes.hasMoreElements(), i++, "getnodes reomve all has no elements");

	}
	catch(ProbabilityException e) {
		checkIfTrue(false, i++, "normal create-remove caused a prob exception");
	}

	// ********
	// now lets do some illegal create oberations - bad values, bad probs sums
	// I need to verify that a removed node does not screw up the net's operations
	try {
		// num values greater than num probs
		BayesNetworkNode bnn1 = bn.createNode(values2, probs1);
		checkIfTrue(false, i++, "createnode - Mismatched imput sizes1");
	}
	catch (ProbabilityException e) {
		Enumeration enumNodes = bn.getNodes();
		checkIfTrue(!enumNodes.hasMoreElements(), i++, "createnode - Mismatched imput sizes1");
	}

	try {
		// num values less than num probs
		BayesNetworkNode bnn1 = bn.createNode(values1, probs2);
		checkIfTrue(false, i++, "createnode - Mismatched imput sizes2");
	}
	catch (ProbabilityException e) {
		Enumeration enumNodes = bn.getNodes();
		checkIfTrue(!enumNodes.hasMoreElements(), i++, "createnode - Mismatched imput sizes2");
	}

	try {
		// values has dups
		values1[2] = "a";
		BayesNetworkNode bnn1 = bn.createNode(values1, probs1);
		checkIfTrue(false, i++, "createnode - dup values");
	}
	catch (ProbabilityException e) {
		Enumeration enumNodes = bn.getNodes();
		checkIfTrue(!enumNodes.hasMoreElements(), i++, "createnode - dup values");
	}

	try {
		// probs sum less than 1.0
		probs2[0] = 0;
		BayesNetworkNode bnn1 = bn.createNode(values2, probs2);
		checkIfTrue(false, i++, "createnode - bad prob sum 1");
	}
	catch (ProbabilityException e) {
		Enumeration enumNodes = bn.getNodes();
		checkIfTrue(!enumNodes.hasMoreElements(), i++, "createnode - bad prob sum 1");
	}

	try {
		// probs sum greater than 1.0
		probs2[0] = .4;
		BayesNetworkNode bnn1 = bn.createNode(values2, probs2);
		checkIfTrue(false, i++, "createnode - bad prob sum 2");
	}
	catch (ProbabilityException e) {
		Enumeration enumNodes = bn.getNodes();
		checkIfTrue(!enumNodes.hasMoreElements(), i++, "createnode - bad prob sum 2");
	}

	
	//**** now test create arc and remove arcs using: getParents, getChildren
	//**** check that removing something removes its arcs
	BayesNetworkNode bnn1 = null;
	BayesNetworkNode bnn2= null;
	BayesNetworkNode bnn3= null;
	BayesNetworkNode bnn4= null;
	BayesNetworkNode bnn5= null;
	BayesNetworkNode bnn6= null;
	try {
		String[] values = {"a", "b"};
		double[] probs = {0.5, 0.5};
		bnn1 = bn.createNode(values, probs);
		bnn2 = bn.createNode(values, probs);
		bnn3 = bn.createNode(values, probs);
		bnn4 = bn.createNode(values, probs);
		bnn5 = bn.createNode(values, probs);
		bnn6 = bn.createNode(values, probs);
				// get parents and children of a node with no arcs
		testBnnEnumeration(i++, "no arcs - parents", bnn2.getParents(), "");
		testBnnEnumeration(i++, "no arcs - parents2", bnn5.getParents(), "");
		testBnnEnumeration(i++, "no arcs - children", bnn1.getChildren(), "");
		testBnnEnumeration(i++, "no arcs - children2", bnn5.getChildren(), "");


		// add one arc and get parents and children
		bn.createArc(bnn1, bnn3);
		testBnnEnumeration(i++, "one arcs - parents", bnn1.getParents(), "");
		testBnnEnumeration(i++, "one arcs - parents2", bnn3.getParents(), "1");
		testBnnEnumeration(i++, "one arcs - Children", bnn1.getChildren(), "3");
		testBnnEnumeration(i++, "one arcs - Children2", bnn3.getChildren(), "");

		// create multiple arcs and multiple levels
		bn.createArc(bnn2, bnn3);
		bn.createArc(bnn4, bnn3);
		bn.createArc(bnn3, bnn5);
		bn.createArc(bnn3, bnn6);
		testBnnEnumeration(i++, "multiple arcs - parents", bnn1.getParents(), "");
		testBnnEnumeration(i++, "multiple arcs - parents2", bnn3.getParents(), "1 2 4");
		testBnnEnumeration(i++, "multiple arcs - parents3", bnn5.getParents(), "3");
		testBnnEnumeration(i++, "multiple arcs - Children", bnn1.getChildren(), "3");
		testBnnEnumeration(i++, "multiple arcs - Children2", bnn4.getChildren(), "3");
		testBnnEnumeration(i++, "multiple arcs - Children3", bnn3.getChildren(), "6 5");
		testBnnEnumeration(i++, "multiple arcs - Children2", bnn5.getChildren(), "");

		// add arcs twice
		bn.createArc(bnn1, bnn3);
		bn.createArc(bnn3, bnn6);
		testBnnEnumeration(i++, "twice add arcs - parents", bnn1.getParents(), "");
		testBnnEnumeration(i++, "twice add arcs - parents2", bnn3.getParents(), "1 2 4");
		testBnnEnumeration(i++, "twice add arcs - Children", bnn1.getChildren(), "3");
		testBnnEnumeration(i++, "twice add arcs - Children2", bnn6.getParents(), "3");
		testBnnEnumeration(i++, "twice add arcs - Children3", bnn3.getChildren(), "4 5");

		// remove arcs
		bn.removeArc(bnn1, bnn3);
		bn.removeArc(bnn3, bnn6);
		testBnnEnumeration(i++, "remove arcs - parents", bnn6.getParents(), "");
		testBnnEnumeration(i++, "remove arcs - parents2", bnn3.getParents(), "2 4");
		testBnnEnumeration(i++, "remove arcs - Children", bnn1.getChildren(), "");
		testBnnEnumeration(i++, "remove arcs - Children2", bnn3.getChildren(), "5");

		// remove arcs twice
		bn.removeArc(bnn1, bnn3);
		bn.removeArc(bnn3, bnn6);
		testBnnEnumeration(i++, "remove2 arcs - parents", bnn6.getParents(), "");
		testBnnEnumeration(i++, "remove2 arcs - parents2", bnn3.getParents(), "2 4");
		testBnnEnumeration(i++, "remove2 arcs - Children", bnn1.getChildren(), "");
		testBnnEnumeration(i++, "remove2 arcs - Children2", bnn3.getChildren(), "5");

		// remove invalid arcs
		bn.removeArc(bnn1, bnn5);
		testBnnEnumeration(i++, "remove2 arcs - parents", bnn5.getParents(), "3");
		testBnnEnumeration(i++, "remove2 arcs - parents2", bnn3.getParents(), "2 4");
		testBnnEnumeration(i++, "remove2 arcs - Children", bnn1.getChildren(), "");
		testBnnEnumeration(i++, "remove2 arcs - Children2", bnn3.getChildren(), "5");

		// remove a node and see if arcs are gone
		bn.createArc(bnn1, bnn3);
		bn.createArc(bnn3, bnn6);
		bn.removeNode(bnn3);
		testBnnEnumeration(i++, "removed node - no arcs - parents", bnn5.getParents(), "");
		testBnnEnumeration(i++, "removed node - no arcs - parents2", bnn3.getParents(), "");
		testBnnEnumeration(i++, "removed node - no arcs - children", bnn3.getChildren(), "");
		testBnnEnumeration(i++, "removed node - no arcs - children2", bnn2.getChildren(), "");
		testBnnEnumeration(i++, "removed node - no arcs - getnodes", bn.getNodes(), "1 2 4 5 6");

		//remove an arc involving a removed node
		bn.removeArc(bnn1, bnn3);
		testBnnEnumeration(i++, "no arcs - parents", bnn5.getParents(), "");
		testBnnEnumeration(i++, "no arcs - parents2", bnn3.getParents(), "");
		testBnnEnumeration(i++, "no arcs - children", bnn3.getChildren(), "");
		testBnnEnumeration(i++, "no arcs - children2", bnn2.getChildren(), "");
		testBnnEnumeration(i++, "no arcs - getnodes", bn.getNodes(), "1 2 4 5 6");

	}
	catch(ProbabilityException e) {
		checkIfTrue(false, i++, "prob exception on valid arc op");
	}
	catch(InvalidArcException e) {
		checkIfTrue(false, i++, "invalid arc exception on valid arc op");
	}

	try {
		// create arcs on a removed node, remove arcs on removed node
		bn.createArc(bnn1, bnn3);
		testBnnEnumeration(i++, "create are with removed node - parents", bnn3.getParents(), "");
		testBnnEnumeration(i++, "create are with removed node - children", bnn1.getChildren(), "");
		testBnnEnumeration(i++, "create are with removed node - getnodes", bn.getNodes(), "1 2 4 5 6");
		checkIfTrue(true, i++, "create arc with removed node");
	}
	catch(InvalidArcException e) {
		checkIfTrue(false, i++, "create arc with removed node");
		
	}

	try {
		// create a loop
		bn.createArc(bnn1, bnn2);
		bn.createArc(bnn2, bnn4);
		bn.createArc(bnn4, bnn5);
		bn.createArc(bnn5, bnn1);
		checkIfTrue(false, i++, "create are with removed node");
	}
	catch(InvalidArcException e) {
		checkIfTrue(true, i++, "create loop");
		testBnnEnumeration(i++, "create loop - parents", bnn5.getParents(), "4");
		testBnnEnumeration(i++, "create loop - parents", bnn1.getParents(), "");
		testBnnEnumeration(i++, "create loop - children", bnn1.getChildren(), "2");
		testBnnEnumeration(i++, "create loop - children", bnn5.getChildren(), "");
		testBnnEnumeration(i++, "create loop - getnodes", bn.getNodes(), "1 2 4 5 6");
	}

	
	//******* now test all the other things by doing an example
	performDogProblem(new GNUJavaBayesNet());

}

public static void performDogProblem(BayesNetwork bn) {
	// requires:bn can't be null and must be empty
    // effects: performs the dog problem from JavaBayes documentation
	
	String[] values = {"true", "false"};
	double[] probsF =     {0.15, 0.85};
	double[] probsB =     {0.01, 0.99};
	double[] probsLF =    {0.60, 0.40};
	double[] probsLFc =   {0.05, 0.95};
	double[] probsDFB =   {0.99, 0.01};
	double[] probsDFBc =  {0.90, 0.10};
	double[] probsDFcB =  {0.97, 0.03};
	double[] probsDFcBc = {0.30, 0.70};
	double[] probsHD =    {0.70, 0.30};
	double[] probsHDc =   {0.01, 0.99};

	try {
		System.out.println("Creating dog network");
		BayesNetworkNode bnnF = bn.createNode(values, probsF);
		BayesNetworkNode bnnB = bn.createNode(values, probsB);
		BayesNetworkNode bnnL = bn.createNode(values, probsF); // this is just a temporay assignment of probs
		BayesNetworkNode bnnD = bn.createNode(values, probsF); // this is just a temporay assignment of probs
		BayesNetworkNode bnnH = bn.createNode(values, probsF); // this is just a temporay assignment of probs

		// create and setup f - l arc
		String[] Values1 = {"true"};
		String[] Values2 = {"false"};
		BayesNetworkNode[] aBNN1node = {bnnF};
		bn.createArc(bnnF, bnnL);
		bnnL.changeProbFunction(aBNN1node, Values1, probsLF);
		testDoubleArray("getprob on l", bnnL.getProb(aBNN1node, Values1), probsLF);
		bnnL.changeProbFunction(aBNN1node, Values2, probsLFc);
		testDoubleArray("getprob on l", bnnL.getProb(aBNN1node, Values2), probsLFc);
		System.out.println("Created F-L");

		// create f -d and b - d
		BayesNetworkNode[] aBNN2node = {bnnF, bnnB};
		String[] Values3 = {"true", "true"};
		String[] Values4 = {"true", "false"};
		String[] Values5 = {"false", "true"};
		String[] Values6 = {"false", "false"};
		bn.createArc(bnnB, bnnD);
		bn.createArc(bnnF, bnnD);
		bnnD.changeProbFunction(aBNN2node, Values3, probsDFB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values3), probsDFB);
		bnnD.changeProbFunction(aBNN2node, Values4, probsDFBc);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values4), probsDFBc);
		bnnD.changeProbFunction(aBNN2node, Values5, probsDFcB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values5), probsDFcB);
		bnnD.changeProbFunction(aBNN2node, Values6, probsDFcBc);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values6), probsDFcBc);
		System.out.println("Created F-D B-D");

		// lets do some random testing on changeProb for invalid parent
		// cases:  invalid parent, parent twice, invalid value for a parent
		
		// invalid parent
		aBNN2node[0] = bnnH;
		try {
			bnnD.changeProbFunction(aBNN2node, Values3, probsF);
			checkIfTrue(false, 0, "invalid parent");
		}
		catch(ProbabilityException e) {
			checkIfTrue(true, 0, "invalid parent");
		}
		aBNN2node[0] = bnnF;
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values3), probsDFB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values4), probsDFBc);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values5), probsDFcB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values6), probsDFcBc);

		// removed node
		BayesNetworkNode bnnInvalid = bn.createNode(values, probsB);
		bn.removeNode(bnnInvalid);
		aBNN2node[0] = bnnInvalid;
		try {
			bnnD.changeProbFunction(aBNN2node, Values3, probsF);
			checkIfTrue(false, 0, "removed parent");
		}
		catch(ProbabilityException e) {
			checkIfTrue(true, 0, "removed parent");
		}
		aBNN2node[0] = bnnF;
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values3), probsDFB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values4), probsDFBc);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values5), probsDFcB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values6), probsDFcBc);

		// parent twice
		aBNN2node[0] = bnnB;
		try {
			bnnD.changeProbFunction(aBNN2node, Values3, probsF);
			checkIfTrue(false, 0, "duplicate parent");
		}
		catch(ProbabilityException e) {
			checkIfTrue(true, 0, "duplicate parent");
		}
		aBNN2node[0] = bnnF;
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values3), probsDFB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values4), probsDFBc);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values5), probsDFcB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values6), probsDFcBc);

		// right parents, bad values
		Values3[0] = "truuuuuue";
		try {
			bnnD.changeProbFunction(aBNN2node, Values3, probsF);
			checkIfTrue(false, 0, "bad parent value");
		}
		catch(ProbabilityException e) {
			checkIfTrue(true, 0, "bad parent value");
		}
		Values3[0] = "true";
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values3), probsDFB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values4), probsDFBc);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values5), probsDFcB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values6), probsDFcBc);

		// puts it back right
		bnnD.changeProbFunction(aBNN2node, Values3, probsDFB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values3), probsDFB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values4), probsDFBc);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values5), probsDFcB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values6), probsDFcBc);


		//create d-h link
		bn.createArc(bnnD, bnnH);
		aBNN1node[0] = bnnD;
		bnnH.changeProbFunction(aBNN1node, Values1, probsHD);
		bnnH.changeProbFunction(aBNN1node, Values2, probsHDc);
		System.out.println("Created D-H");

		//should be all set - lets do some inferences with no observations
		// here are the expected inferences based on JavaBayes
		{
			double[] fInf=  {0.15, 0.85};
			double[] lInf = {0.1325, 0.8674999999999999};
			double[] bInf = {0.01, 0.99};
			double[] dInf = {0.39582999999999996, 0.60417};
			double[] hInf = {0.2831227, 0.7168773};

			testDoubleArray("F inference", fInf, bn.inferenceOnNode(bnnF));
			testDoubleArray("L inference", lInf, bn.inferenceOnNode(bnnL));
			testDoubleArray("B inference", bInf, bn.inferenceOnNode(bnnB));
			testDoubleArray("D inference", dInf, bn.inferenceOnNode(bnnD));
			testDoubleArray("H inference", hInf, bn.inferenceOnNode(bnnH));
		}

		// lets make an observation and see its effect
		{
			bnnF.makeObservation("true");
			checkIfTrue(bnnF.getObservation().equals("true"), 0, "getobsrvation()");

			double[] fInf=  {1.0, 0.0};
			double[] lInf = {0.6, 0.4};
			double[] bInf = {0.01, 0.99};
			double[] dInf = {0.9009, 0.09910000000000001};
			double[] hInf = {0.631621, 0.368379};

			testDoubleArray("F inference", fInf, bn.inferenceOnNode(bnnF));
			testDoubleArray("L inference", lInf, bn.inferenceOnNode(bnnL));
			testDoubleArray("B inference", bInf, bn.inferenceOnNode(bnnB));
			testDoubleArray("D inference", dInf, bn.inferenceOnNode(bnnD));
			testDoubleArray("H inference", hInf, bn.inferenceOnNode(bnnH));
		}

	    // lets make an observation and see its effect
		{
			bnnF.clearObservation();
			checkIfTrue((bnnF.getObservation() == null), 1, "getObservaton()");
			bnnH.makeObservation("false");

			double[] fInf=  {0.07707992706701691, 0.9229200729329831};
			double[] lInf = {0.09239395988685929, 0.9076060401131407};
			double[] bInf = {0.004444693673519862, 0.9955553063264801};
			double[] dInf = {0.16564759408618462, 0.8343524059138154};
			double[] hInf = {0.0, 1.0};

			testDoubleArray("F inference", fInf, bn.inferenceOnNode(bnnF));
			testDoubleArray("L inference", lInf, bn.inferenceOnNode(bnnL));
			testDoubleArray("B inference", bInf, bn.inferenceOnNode(bnnB));
			testDoubleArray("D inference", dInf, bn.inferenceOnNode(bnnD));
			testDoubleArray("H inference", hInf, bn.inferenceOnNode(bnnH));
		}

		// multiple observations and see its effect
		{
			bnnL.makeObservation("true");
			bnnH.makeObservation("true");
			bnnB.makeObservation("true");

			double[] fInf=  {0.6836110981734096, 0.31638890182659035};
			double[] lInf = {1.0, 0.0};
			double[] bInf = {1.0, 0.0};
			double[] dInf = {0.9997616418765086, 2.38358123491426E-4};
			double[] hInf = {1.0, 0.0};

			testDoubleArray("F inference", fInf, bn.inferenceOnNode(bnnF));
			testDoubleArray("L inference", lInf, bn.inferenceOnNode(bnnL));
			testDoubleArray("B inference", bInf, bn.inferenceOnNode(bnnB));
			testDoubleArray("D inference", dInf, bn.inferenceOnNode(bnnD));
			testDoubleArray("H inference", hInf, bn.inferenceOnNode(bnnH));
		}

		// undo all observations and see if we are back to normal
		{
			bnnF.clearObservation();
			bnnH.clearObservation();
			bnnB.clearObservation();
			bnnL.clearObservation();
			bnnD.clearObservation();

			double[] fInf=  {0.15, 0.85};
			double[] lInf = {0.1325, 0.8674999999999999};
			double[] bInf = {0.01, 0.99};
			double[] dInf = {0.39582999999999996, 0.60417};
			double[] hInf = {0.2831227, 0.7168773};

			testDoubleArray("F inference", fInf, bn.inferenceOnNode(bnnF));
			testDoubleArray("L inference", lInf, bn.inferenceOnNode(bnnL));
			testDoubleArray("B inference", bInf, bn.inferenceOnNode(bnnB));
			testDoubleArray("D inference", dInf, bn.inferenceOnNode(bnnD));
			testDoubleArray("H inference", hInf, bn.inferenceOnNode(bnnH));
		}

		// remove a node an redo the inferences
		{
			bnnF.makeObservation("true");
			bn.removeNode(bnnF);

			double[] lInf = {0.5, 0.5};
			double[] bInf = {0.01, 0.99};
			double[] dInf = {0.5, 0.5};
			double[] hInf = {0.355, 0.645};

			testDoubleArray("L inference", lInf, bn.inferenceOnNode(bnnL));
			testDoubleArray("B inference", bInf, bn.inferenceOnNode(bnnB));
			testDoubleArray("D inference", dInf, bn.inferenceOnNode(bnnD));
			testDoubleArray("H inference", hInf, bn.inferenceOnNode(bnnH));
		}
	}
	catch(ProbabilityException e) {
		checkIfTrue(false, 1, "Prob exception for legal operations");
	}
	catch(InvalidArcException e) {
		checkIfTrue(false, 1, "InvalidArc exception for legal operations");
	}
	catch(InvalidValueException e){
	  checkIfTrue(false, 1, "Invalid Value");
	}
}

public static void testDoubleArray(String output, double[] dArray1, double[] dArray2) {
	if (dArray1.length != dArray2.length) {
		System.out.println("***Failure " + output + " incorrect sized array");
		return;
	}

	boolean bFail = false;
	for(int x = 0; x < dArray1.length; x++) {
		if (java.lang.Math.abs(dArray1[x]- dArray2[x]) > 0.001) {
			System.out.println("***Failure " + output + " mismatched elements: " + x + " " + dArray1[x] +
				" " + dArray2[x]);
			bFail = true;
		}
	}

	if (!bFail)
		System.out.println(output + ": ok");
}




public static void testBnnEnumeration(int n, String output, Enumeration enum, String testString) {
	// requires: String testString is of form "ID1 ID2 ..." where each entry
	//           is the ID of a BayesNetworkNode object.  none of the strings or the enum can be null
    // effects: tests the enum of BayesNetworkNode returns what's in testString

	boolean testPassed = true;
	boolean bVerbose = false;

	if (bVerbose)
		System.out.println("Test string is " + testString);

	StringTokenizer st = new StringTokenizer(testString);
    Vector viBNN = new Vector();
    while(st.hasMoreElements()) {
		
		try {
			String s;
			viBNN.addElement(new Integer(s = (String)st.nextElement()));
			if (bVerbose)
				System.out.println("Adding to collection " + s);
		}
		catch(NumberFormatException e) {
			System.out.println("*****************Malformed interger in testBNNEnumeration");
		}
	}

	int iNumBNN = 0;
	while (enum.hasMoreElements()) {
		iNumBNN++;
		int iID = ((BayesNetworkNode)enum.nextElement()).getUniqueID();
		if (bVerbose)
			System.out.println("Enumeration returned " + iID);
		if (!viBNN.contains(new Integer(iID))) {
			System.out.println("***Failure " + n + " " + output + " : " + iID + " not found");
			testPassed = false;
		}
	}

	if (iNumBNN != viBNN.size()) {
		System.out.println("***Failure " + n + " " + output + " : enumeration size was wrong.  expected " +
			viBNN.size() + " but instead saw " + iNumBNN);
		testPassed = false;
	}
	
	
	if (testPassed)
		System.out.println(n + ": " + output + " : ok");
}

public static void compareBayesNodes(int n, String output, BayesNetworkNode bnn, String[] values, double[] probs) {
	String[] nodeValues = bnn.getValues();
	double[] nodeProbs = null;
	try {
		nodeProbs = bnn.getProb(null, null);
	}
	catch(ProbabilityException e) {
		checkIfTrue(false, n, output + ": Couldn't get probs");
		return;
	}
	catch(InvalidValueException e){
	  checkIfTrue(false, n, "Invalid values");
	  return;
	}
	
	// now lets compare the values
	if (nodeValues.length != values.length) {
		checkIfTrue(false, n, output + " length of values unequal");
		return;
	}

	for(int i=0; i < nodeValues.length; i++)
		checkIfTrue(nodeValues[i].equals(values[i]), n, output + " comparing values " + i);

	if (nodeProbs.length != probs.length) {
		checkIfTrue(false, n, output + " length of probs unequal");
		return;
	}

	for(int i=0; i < nodeProbs.length; i++)
		checkIfTrue((nodeProbs[i] == probs[i]), n, output + " comparing probs " + i);
}



  public static void testPedigreeClass() throws InvalidDiseaseException{ //throw added when new and old AutosomalDiseases were switched
	System.out.println("********** Testing Pedigree Class");
	int i = 0;
	Disease d = new AutosomalDisease();
	
	Pedigree ped = new Pedigree(d);

	Person p1 = new Person(1, "Jason", Person.MALE, d);
	Person p2 = new Person(2, "Eric", Person.MALE, d);
	Person p3 = new Person(3, "Julie", Person.FEMALE, d);
	Person p4 = new Person(4, "Julie", Person.FEMALE, d);
	Person p5 = new Person(5, "Joe", Person.UNKNOWN, d);

	// for init, with zero people, make sure all methods work
	testPersonEnumeration(i++, "getPeople on empty", ped.getPeople(), "");
	testPersonEnumeration(i++, "getSpouses on empty", ped.getSpouses(p1), "");
	testPersonEnumeration(i++, "getParents on empty", ped.getParents(p1), "");
	testPersonEnumeration(i++, "getChildren on empty", ped.getChildren(p1), "");
	testPersonEnumeration(i++, "getChildren2 on empty", ped.getChildren(p1, p2), "");
	testPersonEnumeration(i++, "getDescendents on empty", ped.getDescendents(p1), "");
	testPersonEnumeration(i++, "getAncestors on empty", ped.getAncestors(p1), "");

	try {
		ped.removePerson(p1);  // should do nothing
		ped.removePerson(p2);  // should do nothing
	}
	catch(InvalidRelationshipException e) {
		checkIfTrue(false, i++, "Valid remove cause exception");
	}

	testPersonEnumeration(i++, "getPeople on empty", ped.getPeople(), "");
	testPersonEnumeration(i++, "getSpouses on empty", ped.getSpouses(p1), "");
	testPersonEnumeration(i++, "getParents on empty", ped.getParents(p1), "");
	testPersonEnumeration(i++, "getChildren on empty", ped.getChildren(p1), "");
	testPersonEnumeration(i++, "getChildren2 on empty", ped.getChildren(p1, p2), "");
	testPersonEnumeration(i++, "getDescendents on empty", ped.getDescendents(p1), "");
	testPersonEnumeration(i++, "getAncestors on empty", ped.getAncestors(p1), "");

	// now lets add some people to test add, remove, and getPeople
	try {
	ped.addPerson(p1);
	ped.addPerson(p2);
	ped.addPerson(p3);
	ped.addPerson(p4);
	testPersonEnumeration(i++, "getPeople on 4", ped.getPeople(), "1-Jason-0" + " 2-Eric-0"  +
		" 3-Julie-1" + " 4-Julie-1");
	ped.removePerson(p1);
	testPersonEnumeration(i++, "getPeople on 3", ped.getPeople(), "2-Eric-0" + " 3-Julie-1" + " 4-Julie-1");
	ped.removePerson(p3);
	testPersonEnumeration(i++, "getPeople on 2", ped.getPeople(), "2-Eric-0" + " 4-Julie-1");
	// remove someone already gone
	ped.removePerson(p3);
	testPersonEnumeration(i++, "getPeople on 2 again", ped.getPeople(), "2-Eric-0" + " 4-Julie-1");
	ped.addPerson(p3);
	testPersonEnumeration(i++, "getPeople on 3", ped.getPeople(), "2-Eric-0" +	" 3-Julie-1" + " 4-Julie-1");
	ped.addPerson(p4); // add a person twice
	testPersonEnumeration(i++, "getPeople on 3 again", ped.getPeople(), "2-Eric-0" + " 3-Julie-1" + " 4-Julie-1");
	// remove everyone
	ped.removePerson(p1);
	ped.removePerson(p2);
	ped.removePerson(p3);
	ped.removePerson(p4);
	testPersonEnumeration(i++, "getPeople on empty", ped.getPeople(), "");
	}
	catch(InvalidRelationshipException e) {
		checkIfTrue(false, i++, "Valid remove cause exception");
	}


	// test the addMarriage and remove Marriage
	// the cases are normal, when one or two aren't in pedigree, illegal sex marriages, marriaged twice to
	//   same person,  married to onesself, married to multiple people, remove person who is married, ...
	ped.addPerson(p1);
	ped.addPerson(p2);
	ped.addPerson(p3);
	ped.addPerson(p4);

	
	try {
		// normal marriage
		ped.makeMarriage(p1, p3);
		ped.makeMarriage(p2, p4);
		ped.makeMarriage(p1, p4);
		ped.makeMarriage(p2, p3);
		testPersonEnumeration(i++, "test normal marriage", ped.getSpouses(p1), "3-Julie-1 4-Julie-1");
		testPersonEnumeration(i++, "test normal marriage", ped.getSpouses(p2), "3-Julie-1 4-Julie-1");
		testPersonEnumeration(i++, "test normal marriage", ped.getSpouses(p3), "1-Jason-0 2-Eric-0");
		testPersonEnumeration(i++, "test normal marriage", ped.getSpouses(p4), "2-Eric-0 1-Jason-0");

		// do normal remove marriage
		ped.removeMarriage(p1, p3);
		ped.removeMarriage(p2, p4);
		testPersonEnumeration(i++, "remove marriage", ped.getSpouses(p1), "4-Julie-1");
		testPersonEnumeration(i++, "remove marriage", ped.getSpouses(p2), "3-Julie-1");
		testPersonEnumeration(i++, "remove marriage", ped.getSpouses(p3), "2-Eric-0");
		testPersonEnumeration(i++, "remove marriage", ped.getSpouses(p4), "1-Jason-0");
		
		// remove marriage twice
		ped.removeMarriage(p3, p1);
		ped.removeMarriage(p4, p2);
		ped.removeMarriage(p1, p1);   //some invalid marriage
		ped.removeMarriage(p2, p1);   //some invalid marriage
		testPersonEnumeration(i++, "remove twice marriage", ped.getSpouses(p1), "4-Julie-1");
		testPersonEnumeration(i++, "remove twice marriage", ped.getSpouses(p2), "3-Julie-1");
		testPersonEnumeration(i++, "remove twice marriage", ped.getSpouses(p3), "2-Eric-0");
		testPersonEnumeration(i++, "remove twice marriage", ped.getSpouses(p4), "1-Jason-0");

		// add marriage twice
		ped.makeMarriage(p1, p3);
		ped.makeMarriage(p2, p4);
		ped.makeMarriage(p1, p3);
		ped.makeMarriage(p2, p4);
		testPersonEnumeration(i++, "add twice marriage", ped.getSpouses(p1), "3-Julie-1 4-Julie-1");
		testPersonEnumeration(i++, "add twice marriage", ped.getSpouses(p2), "3-Julie-1 4-Julie-1");
		testPersonEnumeration(i++, "add twice marriage", ped.getSpouses(p3), "1-Jason-0 2-Eric-0");
		testPersonEnumeration(i++, "add twice marriage", ped.getSpouses(p4), "2-Eric-0 1-Jason-0");
		
		//remove all marriages
		ped.removeMarriage(p3, p1);
		ped.removeMarriage(p4, p2);
		ped.removeMarriage(p4, p1);
		ped.removeMarriage(p3, p2);
		testPersonEnumeration(i++, "remove all marriage", ped.getSpouses(p1), "");
		testPersonEnumeration(i++, "remove all marriage", ped.getSpouses(p2), "");
		testPersonEnumeration(i++, "remove all marriage", ped.getSpouses(p3), "");
		testPersonEnumeration(i++, "remove all marriage", ped.getSpouses(p4), "");

		//lets remove people and do some add marriages on them
		ped.removePerson(p1);
		ped.removePerson(p2);
		ped.removePerson(p3);
		ped.removePerson(p4);
		ped.makeMarriage(p1, p3);
		testPersonEnumeration(i++, "add new person marriage", ped.getSpouses(p1), "3-Julie-1");
		testPersonEnumeration(i++, "add new person marriage", ped.getSpouses(p3), "1-Jason-0");
		ped.makeMarriage(p1, p4);
		testPersonEnumeration(i++, "add new person marriage", ped.getSpouses(p1), "3-Julie-1 4-Julie-1");
		testPersonEnumeration(i++, "add new person marriage", ped.getSpouses(p3), "1-Jason-0");
		testPersonEnumeration(i++, "add new person marriage", ped.getSpouses(p4), "1-Jason-0");

		testPersonEnumeration(i++, "add new person marriage", ped.getPeople(), "1-Jason-0 3-Julie-1 4-Julie-1");
	}
	catch(InvalidRelationshipException e) {
		// since those were all legal marriages, should never get here
		checkIfTrue(false, i++, "An exception occurred on a legal marriage");
	}

	// now lets do some illegal marriages
	// make sure people aren't added to ped by illegal marriages

	// lets try removing someone who is married
	try {
		ped.removePerson(p1);
		checkIfTrue(false, i++, "Illegal remove occurred");
	}
	catch(InvalidRelationshipException e) {
		testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p1), "3-Julie-1 4-Julie-1");
		testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p3), "1-Jason-0");
		testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p4), "1-Jason-0");
		testPersonEnumeration(i++, "remove person marriage", ped.getPeople(), "1-Jason-0 3-Julie-1 4-Julie-1");
	}

	//marriage to oneself
	try {
		ped.removeMarriage(p1, p3);
		ped.removeMarriage(p1, p4);
		ped.removePerson(p1);
		ped.makeMarriage(p1, p1);
		checkIfTrue(false, i++, "Marriage to oneself");
	}
	catch(InvalidRelationshipException e) {
		checkIfTrue(true, i++, "Marriage to oneself");
		// p1 wasn't even in ped, so make sure this is still the case
		testPersonEnumeration(i++, "illegal marraige doesn't add person", ped.getPeople(), "3-Julie-1 4-Julie-1");
	}
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p1), "");
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p2), "");
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p3), "");
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p4), "");

	try {
		ped.makeMarriage(p3, p3);
		checkIfTrue(false, i++, "Marriage to oneself");
	}
	catch(InvalidRelationshipException e) {
		checkIfTrue(true, i++, "Marriage to oneself");
	}
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p1), "");
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p2), "");
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p3), "");
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p4), "");

	// marriage to same sex
	try {
		ped.makeMarriage(p1, p2);
		checkIfTrue(false, i++, "Marriage to oneself");
	}
	catch(InvalidRelationshipException e) {
		checkIfTrue(true, i++, "Marriage to oneself");
		testPersonEnumeration(i++, "same sex marriage", ped.getPeople(), "3-Julie-1 4-Julie-1");
	}
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p1), "");
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p2), "");
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p3), "");
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p4), "");

	try {
		ped.makeMarriage(p3, p4);
		checkIfTrue(false, i++, "Marriage to oneself");
	}
	catch(InvalidRelationshipException e) {
		checkIfTrue(true, i++, "Marriage to oneself");
		testPersonEnumeration(i++, "same sex marriage", ped.getPeople(), "3-Julie-1 4-Julie-1");
	}
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p1), "");
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p2), "");
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p3), "");
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p4), "");

	try {
		ped.makeMarriage(p3, p5);
		checkIfTrue(false, i++, "Marriage to oneself");
	}
	catch(InvalidRelationshipException e) {
		checkIfTrue(true, i++, "Marriage to oneself");
		testPersonEnumeration(i++, "illegal marraige to unknown", ped.getPeople(), "3-Julie-1 4-Julie-1");
	}
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p1), "");
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p2), "");
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p3), "");
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p4), "");
	testPersonEnumeration(i++, "remove person marriage", ped.getSpouses(p5), "");


	// *** now test makeChild and removeChild:
	// cases are: normal, people not in pedigree, people not yet married, multiple children for
	// same couple and different couple, unknown sex child
	// illegal cases: invalid marriage, having too many parents, creating a loop
	try {
		ped.addPerson(p1);
		ped.addPerson(p2);
		ped.addPerson(p3);
		ped.addPerson(p4);
		ped.addPerson(p5);

		// normal child
		ped.makeMarriage(p1, p3);
		ped.makeChild(p2, p1, p3);
		ped.makeChild(p4, p1, p3);
		ped.makeChild(p5, p3, p2);
		testPersonEnumeration(i++, "create normal child - spouses", ped.getSpouses(p1), "3-Julie-1");
		testPersonEnumeration(i++, "create normal child - spouses", ped.getSpouses(p3), "1-Jason-0 2-Eric-0");
		testPersonEnumeration(i++, "create normal child - children", ped.getChildren(p3), "2-Eric-0 4-Julie-1 5-Joe-2");
		testPersonEnumeration(i++, "create normal child - children", ped.getChildren(p1), "2-Eric-0 4-Julie-1");
		testPersonEnumeration(i++, "create normal child - children2", ped.getChildren(p1, p3), "2-Eric-0 4-Julie-1");
		testPersonEnumeration(i++, "create normal child - children2 none", ped.getChildren(p1, p2), "");
		testPersonEnumeration(i++, "create normal child - children none", ped.getChildren(p4), "");
		testPersonEnumeration(i++, "create normal child - parents", ped.getParents(p2), "1-Jason-0 3-Julie-1");
		testPersonEnumeration(i++, "create normal child - parents", ped.getParents(p5), "2-Eric-0 3-Julie-1");
		testPersonEnumeration(i++, "create normal child - parents none", ped.getParents(p1), "");

		// normal remove child
		ped.removeChild(p5);
		testPersonEnumeration(i++, "remove normal child - spouses", ped.getSpouses(p1), "3-Julie-1");
		testPersonEnumeration(i++, "remove normal child - children", ped.getChildren(p3), "2-Eric-0 4-Julie-1");
		testPersonEnumeration(i++, "remove normal child - children2", ped.getChildren(p1, p3), "2-Eric-0 4-Julie-1");
		testPersonEnumeration(i++, "remove normal child - children2 none", ped.getChildren(p1, p4), "");
		testPersonEnumeration(i++, "remove normal child - children none", ped.getChildren(p2), "");
		testPersonEnumeration(i++, "remove normal child - parents", ped.getParents(p2), "1-Jason-0 3-Julie-1");
		testPersonEnumeration(i++, "remove normal child - parents", ped.getParents(p5), "");

		ped.removeMarriage(p2, p3);

		// lets try adding twice - and creating three generation - alsi creating a marriage
		ped.makeChild(p5, p2, p4);
		// ped.makeChild(p5, p2, p4); this is not legal
		testPersonEnumeration(i++, "add twice child - spouses", ped.getSpouses(p1), "3-Julie-1");
		testPersonEnumeration(i++, "add twice child - spouses", ped.getSpouses(p2), "4-Julie-1");
		testPersonEnumeration(i++, "add twice child - children", ped.getChildren(p3), "2-Eric-0 4-Julie-1");
		testPersonEnumeration(i++, "add twice child - children2", ped.getChildren(p1, p3), "2-Eric-0 4-Julie-1");
		testPersonEnumeration(i++, "add twice child - children2", ped.getChildren(p2, p4), "5-Joe-2");
		testPersonEnumeration(i++, "add twice child - children", ped.getChildren(p2), "5-Joe-2");
		testPersonEnumeration(i++, "add twice child - parents", ped.getParents(p5), "2-Eric-0 4-Julie-1");

		// remove twice
		ped.removeChild(p2);
		ped.removeChild(p2);
		ped.removeChild(p1);   // should do nothing
		testPersonEnumeration(i++, "remove twice child - spouses", ped.getSpouses(p1), "3-Julie-1");
		testPersonEnumeration(i++, "remove twice child - spouses", ped.getSpouses(p2), "4-Julie-1");
		testPersonEnumeration(i++, "remove twice child - children", ped.getChildren(p3), "4-Julie-1");
		testPersonEnumeration(i++, "remove twice child - children2", ped.getChildren(p1, p3), "4-Julie-1");
		testPersonEnumeration(i++, "remove twice child - children2", ped.getChildren(p2, p4), "5-Joe-2");
		testPersonEnumeration(i++, "remove twice child - children", ped.getChildren(p2), "5-Joe-2");
		testPersonEnumeration(i++, "remove twice child - parents", ped.getParents(p5), "2-Eric-0 4-Julie-1");
		testPersonEnumeration(i++, "remove twice child - parents", ped.getParents(p2), "");
		testPersonEnumeration(i++, "remove twice child - parents", ped.getParents(p1), "");
		testPersonEnumeration(i++, "remove twice child - parents", ped.getPeople(), 
			"1-Jason-0 2-Eric-0 4-Julie-1 3-Julie-1 5-Joe-2");

		
		// try child with people not in pedigree
		ped.removeChild(p5);
		ped.removeChild(p4);
		ped.removeMarriage(p1, p3);
		ped.removeMarriage(p2, p4);

		ped.removePerson(p1);
		ped.removePerson(p2);
		ped.removePerson(p3);
		ped.makeChild(p2, p1, p3);
		testPersonEnumeration(i++, "new person child - spouses", ped.getSpouses(p1), "3-Julie-1");
		testPersonEnumeration(i++, "new person child - spouses", ped.getSpouses(p2), "");
		testPersonEnumeration(i++, "new person child - spouses", ped.getSpouses(p4), "");
		testPersonEnumeration(i++, "new person child - children", ped.getChildren(p3), "2-Eric-0");
		testPersonEnumeration(i++, "new person child - children2", ped.getChildren(p1, p3), "2-Eric-0");
		testPersonEnumeration(i++, "new person child - children2", ped.getChildren(p2, p4), "");
		testPersonEnumeration(i++, "new person child - children", ped.getChildren(p2), "");
		testPersonEnumeration(i++, "new person child - children", ped.getChildren(p4), "");
		testPersonEnumeration(i++, "new person child - parents", ped.getParents(p5), "");
		testPersonEnumeration(i++, "new person child - parents", ped.getPeople(), 
			"1-Jason-0 2-Eric-0 4-Julie-1 3-Julie-1 5-Joe-2");


		//also make sure methods work with nobody in the ped
		ped.removeChild(p2);
		ped.removeMarriage(p1, p3);
		ped.removePerson(p1);
		ped.removePerson(p2);
		ped.removePerson(p3);
		ped.removePerson(p4);
		ped.removePerson(p5);
		testPersonEnumeration(i++, "empty ped - spouses", ped.getSpouses(p1), "");
		testPersonEnumeration(i++, "empty ped - spouses", ped.getSpouses(p2), "");
		testPersonEnumeration(i++, "empty ped - spouses", ped.getSpouses(p4), "");
		testPersonEnumeration(i++, "empty ped - children", ped.getChildren(p3), "");
		testPersonEnumeration(i++, "empty ped - children2", ped.getChildren(p1, p3), "");
		testPersonEnumeration(i++, "empty ped - children2", ped.getChildren(p2, p4), "");
		testPersonEnumeration(i++, "empty ped - children", ped.getChildren(p2), "");
		testPersonEnumeration(i++, "empty ped - children", ped.getChildren(p4), "");
		testPersonEnumeration(i++, "empty ped - parents", ped.getParents(p5), "");
		testPersonEnumeration(i++, "empty ped - people", ped.getPeople(), "");
	}
	catch(InvalidRelationshipException e) {
		checkIfTrue(false, i++, "Exception occured for a legal makeChild");
	}


	//now lets do all the illegal cases

	try {
		// remove a person and make sure all is good
		ped.makeChild(p2, p1, p3);
		ped.removePerson(p2);
		checkIfTrue(false, i++, "Invalid remove with child");
	}
	catch(InvalidRelationshipException e) {
		testPersonEnumeration(i++, "remove person child - spouses", ped.getSpouses(p1), "3-Julie-1");
		testPersonEnumeration(i++, "remove person child - children", ped.getChildren(p3), "2-Eric-0");
		testPersonEnumeration(i++, "remove person child - children2", ped.getChildren(p1, p3), "2-Eric-0");
		testPersonEnumeration(i++, "remove person child - parents", ped.getParents(p2), "1-Jason-0 3-Julie-1");
		testPersonEnumeration(i++, "remove person child - parents", ped.getPeople(), 
			"1-Jason-0 2-Eric-0 3-Julie-1");
	}

	try {
		ped.removeChild(p2);
		ped.removeMarriage(p1, p3);
		ped.removePerson(p1);
		ped.removePerson(p2);
		ped.removePerson(p3);
		ped.makeChild(p3, p1, p2);
		checkIfTrue(false, i++, "illegal marriage in makechild");
	}
	catch(InvalidRelationshipException e) {
		checkIfTrue(true, i++, "illegal marriage in makechild");
		testPersonEnumeration(i++, "illegal marriage - spouses", ped.getSpouses(p1), "");
		testPersonEnumeration(i++, "illegal marriage - spouses", ped.getSpouses(p2), "");
		testPersonEnumeration(i++, "illegal marriage - children", ped.getChildren(p2), "");
		testPersonEnumeration(i++, "illegal marriage - children2", ped.getChildren(p1, p2), "");
		testPersonEnumeration(i++, "illegal marriage - parents", ped.getParents(p3), "");
		testPersonEnumeration(i++, "illegal marriage - people", ped.getPeople(), "");
	}

	try {
		ped.makeChild(p2, p1, p3);
		ped.makeChild(p2, p4, p1);
		checkIfTrue(false, i++, "too many parents");
	}
	catch(InvalidRelationshipException e) {
		checkIfTrue(true, i++, "too many parents");
		testPersonEnumeration(i++, "too many parents - spouses", ped.getSpouses(p1), "3-Julie-1");
		testPersonEnumeration(i++, "too many parents - children", ped.getChildren(p1), "2-Eric-0");
		testPersonEnumeration(i++, "too many parents - children2", ped.getChildren(p1, p3), "2-Eric-0");
		testPersonEnumeration(i++, "too many parents - parents", ped.getParents(p2), "1-Jason-0 3-Julie-1");
		testPersonEnumeration(i++, "too many parents - parents", ped.getPeople(), "1-Jason-0 3-Julie-1 2-Eric-0");
	}

	try {
		// lets create a loop
		ped.makeChild(p1, p4, p2);
		checkIfTrue(false, i++, "loop");
	}
	catch(InvalidRelationshipException e) {
		checkIfTrue(true, i++, "loop");
		testPersonEnumeration(i++, "loop - spouses", ped.getSpouses(p2), "");
		testPersonEnumeration(i++, "loop - spouses", ped.getSpouses(p4), "");
		testPersonEnumeration(i++, "loop - children", ped.getChildren(p3), "2-Eric-0");
		testPersonEnumeration(i++, "loop - children", ped.getChildren(p4), "");
		testPersonEnumeration(i++, "loop - children", ped.getChildren(p2), "");
		testPersonEnumeration(i++, "loop - children2", ped.getChildren(p1, p3), "2-Eric-0");
		testPersonEnumeration(i++, "loop - parents", ped.getParents(p2), "1-Jason-0 3-Julie-1");
		testPersonEnumeration(i++, "loop - parents", ped.getParents(p1), "");
		testPersonEnumeration(i++, "loop - parents", ped.getPeople(), "1-Jason-0 3-Julie-1 2-Eric-0");
	}


	// *** test out ancestors and descendents - only normal case
	try {
		ped.makeChild(p5, p2, p4);
		testPersonEnumeration(i++, "normal desc -", ped.getDescendents(p1), "2-Eric-0 5-Joe-2");
		testPersonEnumeration(i++, "normal desc -", ped.getDescendents(p4), "5-Joe-2");
		testPersonEnumeration(i++, "normal desc -", ped.getDescendents(p2), "5-Joe-2");
		testPersonEnumeration(i++, "normal desc -", ped.getDescendents(p5), "");
		testPersonEnumeration(i++, "normal ancest -", ped.getAncestors(p4), "");
		testPersonEnumeration(i++, "normal ancest -", ped.getAncestors(p5), "1-Jason-0 3-Julie-1 2-Eric-0 4-Julie-1");
		testPersonEnumeration(i++, "normal ancest -", ped.getAncestors(p2), "1-Jason-0 3-Julie-1");
	}
	catch(InvalidRelationshipException e) {
		checkIfTrue(false, i++, "normal make child cauded exception in testin ancest and desc");
	}

}


//
public static void testPersonEnumeration(int n, String output, Enumeration enum, String testString) {
	// requires: String testString is of form "ID-name-sexType ID-name-sexType ..." where each entry
	//           is the output of a person object.  none of the strings or the enum can be null
    // effects: tests the enum of persons returns what's in testString

	boolean testPassed = true;
	boolean bVerbose = false;

	if (bVerbose)
		System.out.println("Test string is " + testString);

	StringTokenizer st = new StringTokenizer(testString);
    Vector vStringPersons = new Vector();
    while(st.hasMoreElements()) {
		String s;
		vStringPersons.addElement(s= (String)st.nextElement());
		if (bVerbose)
			System.out.println("Adding to collection " + s);
	}

	int iNumPerson = 0;
	while (enum.hasMoreElements()) {
		iNumPerson++;
		String sPerson = ((Person)enum.nextElement()).toString();
		if (bVerbose)
			System.out.println("Enumeration returned " + sPerson);
		if (!vStringPersons.contains(sPerson)) {
			System.out.println("***Failure " + n + " " + output + " : " + sPerson + " not found");
			testPassed = false;
		}
	}

	if (iNumPerson != vStringPersons.size()) {
		System.out.println("***Failure " + n + " " + output + " : enumeration size was wrong.  expected " +
			vStringPersons.size() + " but instead saw " + iNumPerson);
		testPassed = false;
	}
	
	
	if (testPassed)
		System.out.println(n + ": " + output + " : ok");
}

public static void checkIfTrue(boolean bCheck, int n, String output) {
	if (bCheck)
		System.out.println(n + ": " + output + " : ok");
	else
		System.out.println("*** Failure *** " + n + ": " + output);
}


} // test Class
