import java.util.*;

//import BayesNetwork.*;
//import GenExceptions.*;

public class testBayesNet {

static int ID1, ID2, ID3, ID4, ID5, ID6;

public static void main(String argv[]) {
	//testPedigreeClass();
	testBayesNet();
}

public static void testBayesNet() {
	int i = 0;
	BayesNetwork bn = new GNUJavaBayesNet(); 

	
	// cases with createNode and removeNode- normal and invalid creations
	String[] values1 = {"a", "b", "c"};
	double[] probs1 = {.33, .33, .33};
	String[] values2 = {"d", "e", "f", "g"};
	double[] probs2 = {.25, .25, .25, .25};

	try {
		BayesNetworkNode bnn1 = bn.createNode(values1, probs1);
		ID1 = bnn1.getUniqueID();
		BayesNetworkNode bnn2 = bn.createNode(values2, probs2);

		//now lets make sure that we can get these nodes back
		Enumeration enumNodes = bn.getNodes();
		
		boolean sawZeroNode = false;
		boolean sawOneNode = false;
		for (int k=0; k < 2; k++) {
			BayesNetworkNode bnnTestNode;
			checkIfTrue(enumNodes.hasMoreElements(), i++, "getnodes has something");
			if (!enumNodes.hasMoreElements())
				break;
			bnnTestNode = (BayesNetworkNode)enumNodes.nextElement();
			if (bnnTestNode.getUniqueID() == ID1) {
				if (sawZeroNode)
					checkIfTrue(false, i++, "saw zero node twice");
				sawZeroNode =true;
				compareBayesNodes(i++, "zero node", bnnTestNode, values1, probs1);
			}
			else {
				if (sawOneNode)
					checkIfTrue(false, i++, "saw one node twice");
				sawOneNode =true;
				compareBayesNodes(i++, "one node", bnnTestNode, values2, probs2);
			}
		}

				
		// lets do a normal remove
		bn.removeNode(bnn1);
		enumNodes = bn.getNodes();
		checkIfTrue(enumNodes.hasMoreElements(), i++, "getnodes reomve has elements");
		if (enumNodes.hasMoreElements())
			compareBayesNodes(i++, "removed one compare", (BayesNetworkNode)enumNodes.nextElement(), values2, probs2);
		checkIfTrue(!enumNodes.hasMoreElements(), i++, "Remove one element");

		// lets add bnn1 back, and remove it twice
		bnn1 = bn.createNode(values1, probs1);
		ID1 = bnn1.getUniqueID();
		enumNodes = bn.getNodes();
		
		sawZeroNode = false;
		sawOneNode = false;
		for (int k=0; k < 2; k++) {
			BayesNetworkNode bnnTestNode;
			checkIfTrue(enumNodes.hasMoreElements(), i++, "getnodes has something");
			if (!enumNodes.hasMoreElements())
				break;
			bnnTestNode = (BayesNetworkNode)enumNodes.nextElement();
			if (bnnTestNode.getUniqueID() == ID1) {
				if (sawZeroNode)
					checkIfTrue(false, i++, "saw zero node twice");
				sawZeroNode =true;
				compareBayesNodes(i++, "zero node", bnnTestNode, values1, probs1);
			}
			else {
				if (sawOneNode)
					checkIfTrue(false, i++, "saw one node twice");
				sawOneNode =true;
				compareBayesNodes(i++, "one node", bnnTestNode, values2, probs2);
			}
		}

		// now remove it twice
		bn.removeNode(bnn1);
		bn.removeNode(bnn1);
		enumNodes = bn.getNodes();
		checkIfTrue(enumNodes.hasMoreElements(), i++, "getnodes reomve2 has elements");
		if (enumNodes.hasMoreElements())
			compareBayesNodes(i++, "removed2 one compare", (BayesNetworkNode)enumNodes.nextElement(), values2, probs2);
		checkIfTrue(!enumNodes.hasMoreElements(), i++, "Remove2 one element");


		// lets remove everything
		bn.removeNode(bnn2);
		enumNodes= bn.getNodes();
		checkIfTrue(!enumNodes.hasMoreElements(), i++, "getnodes reomve all has no elements");

	}
	catch(ProbabilityException e) {
		checkIfTrue(false, i++, "normal create-remove caused a prob exception");
	}

	// ********
	// now lets do some illegal create oberations - bad values, bad probs sums
	// I need to verify that a removed node does not screw up the net's operations
	try {
		// num values greater than num probs
		BayesNetworkNode bnn1 = bn.createNode(values2, probs1);
		checkIfTrue(false, i++, "createnode - Mismatched imput sizes1");
	}
	catch (ProbabilityException e) {
		Enumeration enumNodes = bn.getNodes();
		checkIfTrue(!enumNodes.hasMoreElements(), i++, "createnode - Mismatched imput sizes1");
	}

	try {
		// num values less than num probs
		BayesNetworkNode bnn1 = bn.createNode(values1, probs2);
		checkIfTrue(false, i++, "createnode - Mismatched imput sizes2");
	}
	catch (ProbabilityException e) {
		Enumeration enumNodes = bn.getNodes();
		checkIfTrue(!enumNodes.hasMoreElements(), i++, "createnode - Mismatched imput sizes2");
	}

	try {
		// values has dups
		values1[2] = "a";
		BayesNetworkNode bnn1 = bn.createNode(values1, probs1);
		checkIfTrue(false, i++, "createnode - dup values");
	}
	catch (ProbabilityException e) {
		Enumeration enumNodes = bn.getNodes();
		checkIfTrue(!enumNodes.hasMoreElements(), i++, "createnode - dup values");
	}

	try {
		// probs sum less than 1.0
		probs2[0] = 0;
		BayesNetworkNode bnn1 = bn.createNode(values2, probs2);
		checkIfTrue(false, i++, "createnode - bad prob sum 1");
	}
	catch (ProbabilityException e) {
		Enumeration enumNodes = bn.getNodes();
		checkIfTrue(!enumNodes.hasMoreElements(), i++, "createnode - bad prob sum 1");
	}

	try {
		// probs sum greater than 1.0
		probs2[0] = .4;
		BayesNetworkNode bnn1 = bn.createNode(values2, probs2);
		checkIfTrue(false, i++, "createnode - bad prob sum 2");
	}
	catch (ProbabilityException e) {
		Enumeration enumNodes = bn.getNodes();
		checkIfTrue(!enumNodes.hasMoreElements(), i++, "createnode - bad prob sum 2");
	}

	
	//**** now test create arc and remove arcs using: getParents, getChildren
	//**** check that removing something removes its arcs
	BayesNetworkNode bnn1 = null;
	BayesNetworkNode bnn2= null;
	BayesNetworkNode bnn3= null;
	BayesNetworkNode bnn4= null;
	BayesNetworkNode bnn5= null;
	BayesNetworkNode bnn6= null;
	try {
		String[] values = {"a", "b"};
		double[] probs = {0.5, 0.5};
		bnn1 = bn.createNode(values, probs);
		bnn2 = bn.createNode(values, probs);
		bnn3 = bn.createNode(values, probs);
		bnn4 = bn.createNode(values, probs);
		bnn5 = bn.createNode(values, probs);
		bnn6 = bn.createNode(values, probs);
		ID1 = bnn1.getUniqueID();
		ID2 = bnn2.getUniqueID();
		ID3 = bnn3.getUniqueID();
		ID4 = bnn4.getUniqueID();
		ID5 = bnn5.getUniqueID();
		ID6 = bnn6.getUniqueID();
				// get parents and children of a node with no arcs
		testBnnEnumeration(i++, "no arcs - parents", bnn2.getParents(), "");
		testBnnEnumeration(i++, "no arcs - parents2", bnn5.getParents(), "");
		testBnnEnumeration(i++, "no arcs - children", bnn1.getChildren(), "");
		testBnnEnumeration(i++, "no arcs - children2", bnn5.getChildren(), "");


		// add one arc and get parents and children
		bn.createArc(bnn1, bnn3);
		testBnnEnumeration(i++, "one arcs - parents", bnn1.getParents(), "");
		testBnnEnumeration(i++, "one arcs - parents2", bnn3.getParents(), ""+ID1);
		testBnnEnumeration(i++, "one arcs - Children", bnn1.getChildren(), ""+ID3);
		testBnnEnumeration(i++, "one arcs - Children2", bnn3.getChildren(), "");

		// create multiple arcs and multiple levels
		bn.createArc(bnn2, bnn3);
		bn.createArc(bnn4, bnn3);
		bn.createArc(bnn3, bnn5);
		bn.createArc(bnn3, bnn6);
		testBnnEnumeration(i++, "multiple arcs - parents", bnn1.getParents(), "");
		testBnnEnumeration(i++, "multiple arcs - parents2", bnn3.getParents(), ID1 + " " + ID2 +" "+ ID4);
		testBnnEnumeration(i++, "multiple arcs - parents3", bnn5.getParents(), ""+ID3);
		testBnnEnumeration(i++, "multiple arcs - Children", bnn1.getChildren(), ""+ID3);
		testBnnEnumeration(i++, "multiple arcs - Children2", bnn4.getChildren(), ""+ID3);
		testBnnEnumeration(i++, "multiple arcs - Children3", bnn3.getChildren(), ID6+" "+ ID5);
		testBnnEnumeration(i++, "multiple arcs - Children2", bnn5.getChildren(), "");

		// add arcs twice
		bn.createArc(bnn1, bnn3);
		bn.createArc(bnn3, bnn6);
		testBnnEnumeration(i++, "twice add arcs - parents", bnn1.getParents(), "");
		testBnnEnumeration(i++, "twice add arcs - parents2", bnn3.getParents(), ID1+" "+ID2+" "+ID4);
		testBnnEnumeration(i++, "twice add arcs - Children", bnn1.getChildren(), ""+ID3);
		testBnnEnumeration(i++, "twice add arcs - Children2", bnn6.getParents(), ""+ID3);
		testBnnEnumeration(i++, "twice add arcs - Children3", bnn3.getChildren(), ID6+" "+ ID5);

		// remove arcs
		bn.removeArc(bnn1, bnn3);
		bn.removeArc(bnn3, bnn6);
		testBnnEnumeration(i++, "remove arcs - parents", bnn6.getParents(), "");
		testBnnEnumeration(i++, "remove arcs - parents2", bnn3.getParents(), ID2+" "+ ID4);
		testBnnEnumeration(i++, "remove arcs - Children", bnn1.getChildren(), "");
		testBnnEnumeration(i++, "remove arcs - Children2", bnn3.getChildren(), ID5+"");

		// remove arcs twice
		bn.removeArc(bnn1, bnn3);
		bn.removeArc(bnn3, bnn6);
		testBnnEnumeration(i++, "remove2 arcs - parents", bnn6.getParents(), "");
		testBnnEnumeration(i++, "remove2 arcs - parents2", bnn3.getParents(), ID2+" "+ ID4);
		testBnnEnumeration(i++, "remove2 arcs - Children", bnn1.getChildren(), "");
		testBnnEnumeration(i++, "remove2 arcs - Children2", bnn3.getChildren(), ID5+"");

		// remove invalid arcs
		bn.removeArc(bnn1, bnn5);
		testBnnEnumeration(i++, "remove2 arcs - parents", bnn5.getParents(), ""+ID3);
		testBnnEnumeration(i++, "remove2 arcs - parents2", bnn3.getParents(), ID2+" "+ ID4);
		testBnnEnumeration(i++, "remove2 arcs - Children", bnn1.getChildren(), "");
		testBnnEnumeration(i++, "remove2 arcs - Children2", bnn3.getChildren(), ID5+"");

		// remove a node and see if arcs are gone
		bn.createArc(bnn1, bnn3);
		bn.createArc(bnn3, bnn6);
		bn.removeNode(bnn3);
		testBnnEnumeration(i++, "removed node - no arcs - parents", bnn5.getParents(), "");
		testBnnEnumeration(i++, "removed node - no arcs - parents2", bnn3.getParents(), "");
		testBnnEnumeration(i++, "removed node - no arcs - children", bnn3.getChildren(), "");
		testBnnEnumeration(i++, "removed node - no arcs - children2", bnn2.getChildren(), "");
		testBnnEnumeration(i++, "removed node - no arcs - getnodes", bn.getNodes(), ID1+" "+ID2+" "+
																				ID4+" "+ID5+ " "+ ID6);

		//remove an arc involving a removed node
		bn.removeArc(bnn1, bnn3);
		testBnnEnumeration(i++, "no arcs - parents", bnn5.getParents(), "");
		testBnnEnumeration(i++, "no arcs - parents2", bnn3.getParents(), "");
		testBnnEnumeration(i++, "no arcs - children", bnn3.getChildren(), "");
		testBnnEnumeration(i++, "no arcs - children2", bnn2.getChildren(), "");
		testBnnEnumeration(i++, "no arcs - getnodes", bn.getNodes(), ID1+" "+ID2+" "+
																	ID4+" "+ID5+ " "+ ID6);

	}
	catch(ProbabilityException e) {
		checkIfTrue(false, i++, "prob exception on valid arc op");
	}
	catch(InvalidArcException e) {
		checkIfTrue(false, i++, "invalid arc exception on valid arc op");
	}

	try {
		// create arcs on a removed node, remove arcs on removed node
		bn.createArc(bnn1, bnn3);
		testBnnEnumeration(i++, "create are with removed node - parents", bnn3.getParents(), "");
		testBnnEnumeration(i++, "create are with removed node - children", bnn1.getChildren(), "");
		testBnnEnumeration(i++, "create are with removed node - getnodes", bn.getNodes(), ID1+" "+ID2+" "+
																				ID4+" "+ID5+ " "+ ID6);
		checkIfTrue(true, i++, "create arc with removed node");
	}
	catch(InvalidArcException e) {
		checkIfTrue(false, i++, "create arc with removed node");
		
	}

	try {
		// create a loop
		bn.createArc(bnn1, bnn2);
		bn.createArc(bnn2, bnn4);
		bn.createArc(bnn4, bnn5);
		bn.createArc(bnn5, bnn1);
		checkIfTrue(false, i++, "create are with removed node");
	}
	catch(InvalidArcException e) {
		checkIfTrue(true, i++, "create loop");
		testBnnEnumeration(i++, "create loop - parents", bnn5.getParents(), ""+ID4);
		testBnnEnumeration(i++, "create loop - parents", bnn1.getParents(), "");
		testBnnEnumeration(i++, "create loop - children", bnn1.getChildren(), ""+ID2);
		testBnnEnumeration(i++, "create loop - children", bnn5.getChildren(), "");
		testBnnEnumeration(i++, "create loop - getnodes", bn.getNodes(), ID1+" "+ID2+" "+
																				ID4+" "+ID5+ " "+ ID6);
	}

	try {
		// create a loop
		bn.removeArc(bnn1, bnn2);
		bn.removeArc(bnn2, bnn4);
		bn.removeArc(bnn4, bnn5);
		bn.removeArc(bnn5, bnn1);
		bn.createArc(bnn1, bnn1);
		checkIfTrue(false, i++, "create loop with one node");
	}
	catch(InvalidArcException e) {
		checkIfTrue(true, i++, "create loop2");
		testBnnEnumeration(i++, "create loop2 - parents", bnn1.getParents(), "");
		testBnnEnumeration(i++, "create loop2 - children", bnn1.getChildren(), "");
	}

	
	//******* now test all the other things by doing an example
	performDogProblem(new GNUJavaBayesNet());

}

public static void performDogProblem(BayesNetwork bn) {
	// requires:bn can't be null and must be empty
    // effects: performs the dog problem from JavaBayes documentation
	
	String[] values = {"true", "false"};
	double[] probsF =     {0.15, 0.85};
	double[] probsB =     {0.01, 0.99};
	double[] probsLF =    {0.60, 0.40};
	double[] probsLFc =   {0.05, 0.95};
	double[] probsDFB =   {0.99, 0.01};
	double[] probsDFBc =  {0.90, 0.10};
	double[] probsDFcB =  {0.97, 0.03};
	double[] probsDFcBc = {0.30, 0.70};
	double[] probsHD =    {0.70, 0.30};
	double[] probsHDc =   {0.01, 0.99};

	try {
		System.out.println("Creating dog network");
		BayesNetworkNode bnnF = bn.createNode(values, probsF);
		BayesNetworkNode bnnB = bn.createNode(values, probsB);
		BayesNetworkNode bnnL = bn.createNode(values, probsF); // this is just a temporay assignment of probs
		BayesNetworkNode bnnD = bn.createNode(values, probsF); // this is just a temporay assignment of probs
		BayesNetworkNode bnnH = bn.createNode(values, probsF); // this is just a temporay assignment of probs

		// create and setup f - l arc
		String[] Values1 = {"true"};
		String[] Values2 = {"false"};
		BayesNetworkNode[] aBNN1node = {bnnF};
		bn.createArc(bnnF, bnnL);
		bnnL.changeProbFunction(aBNN1node, Values1, probsLF);
		testDoubleArray("getprob on l", bnnL.getProb(aBNN1node, Values1), probsLF);
		bnnL.changeProbFunction(aBNN1node, Values2, probsLFc);
		testDoubleArray("getprob on l", bnnL.getProb(aBNN1node, Values2), probsLFc);
		System.out.println("Created F-L");

		// create f -d and b - d
		BayesNetworkNode[] aBNN2node = {bnnF, bnnB};
		String[] Values3 = {"true", "true"};
		String[] Values4 = {"true", "false"};
		String[] Values5 = {"false", "true"};
		String[] Values6 = {"false", "false"};
		bn.createArc(bnnB, bnnD);
		bn.createArc(bnnF, bnnD);
		bnnD.changeProbFunction(aBNN2node, Values3, probsDFB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values3), probsDFB);
		bnnD.changeProbFunction(aBNN2node, Values4, probsDFBc);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values4), probsDFBc);
		bnnD.changeProbFunction(aBNN2node, Values5, probsDFcB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values5), probsDFcB);
		bnnD.changeProbFunction(aBNN2node, Values6, probsDFcBc);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values6), probsDFcBc);
		System.out.println("Created F-D B-D");

		// lets do some random testing on changeProb for invalid parent
		// cases:  invalid parent, parent twice, invalid value for a parent
		
		// invalid parent
		aBNN2node[0] = bnnH;
		try {
			bnnD.changeProbFunction(aBNN2node, Values3, probsF);
			checkIfTrue(false, 0, "invalid parent");
		}
		catch(ProbabilityException e) {
			checkIfTrue(true, 0, "invalid parent");
		}
		catch(InvalidValueException e) {
			checkIfTrue(false, 0, "invalid parent");
		}
		aBNN2node[0] = bnnF;
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values3), probsDFB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values4), probsDFBc);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values5), probsDFcB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values6), probsDFcBc);

		// removed node
		BayesNetworkNode bnnInvalid = bn.createNode(values, probsB);
		bn.removeNode(bnnInvalid);
		aBNN2node[0] = bnnInvalid;
		try {
			bnnD.changeProbFunction(aBNN2node, Values3, probsF);
			checkIfTrue(false, 0, "removed parent");
		}
		catch(ProbabilityException e) {
			checkIfTrue(true, 0, "removed parent");
		}
		catch(InvalidValueException e) {
			checkIfTrue(false, 0, "removed parent");
		}
		aBNN2node[0] = bnnF;
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values3), probsDFB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values4), probsDFBc);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values5), probsDFcB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values6), probsDFcBc);

		// parent twice
		aBNN2node[0] = bnnB;
		try {
			bnnD.changeProbFunction(aBNN2node, Values3, probsF);
			checkIfTrue(false, 0, "duplicate parent");
		}
		catch(ProbabilityException e) {
			checkIfTrue(true, 0, "duplicate parent");
		}
		catch(InvalidValueException e) {
			checkIfTrue(false, 0, "duplicate parent");
		}
		aBNN2node[0] = bnnF;
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values3), probsDFB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values4), probsDFBc);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values5), probsDFcB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values6), probsDFcBc);

		// right parents, bad values
		Values3[0] = "truuuuuue";
		try {
			bnnD.changeProbFunction(aBNN2node, Values3, probsF);
			checkIfTrue(false, 0, "bad parent value");
		}
		catch(ProbabilityException e) {
			checkIfTrue(false, 0, "bad parent value");
		}
		catch(InvalidValueException e) {
			checkIfTrue(true, 0, "bad parent value");
		}
		Values3[0] = "true";
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values3), probsDFB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values4), probsDFBc);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values5), probsDFcB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values6), probsDFcBc);

		// puts it back right
		bnnD.changeProbFunction(aBNN2node, Values3, probsDFB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values3), probsDFB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values4), probsDFBc);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values5), probsDFcB);
		testDoubleArray("getprob on D", bnnD.getProb(aBNN2node, Values6), probsDFcBc);


		//create d-h link
		bn.createArc(bnnD, bnnH);
		aBNN1node[0] = bnnD;
		bnnH.changeProbFunction(aBNN1node, Values1, probsHD);
		bnnH.changeProbFunction(aBNN1node, Values2, probsHDc);
		System.out.println("Created D-H");

		//should be all set - lets do some inferences with no observations
		// here are the expected inferences based on JavaBayes
		{
			double[] fInf=  {0.15, 0.85};
			double[] lInf = {0.1325, 0.8674999999999999};
			double[] bInf = {0.01, 0.99};
			double[] dInf = {0.39582999999999996, 0.60417};
			double[] hInf = {0.2831227, 0.7168773};

			testDoubleArray("F inference", fInf, bn.inferenceOnNode(bnnF));
			testDoubleArray("L inference", lInf, bn.inferenceOnNode(bnnL));
			testDoubleArray("B inference", bInf, bn.inferenceOnNode(bnnB));
			testDoubleArray("D inference", dInf, bn.inferenceOnNode(bnnD));
			testDoubleArray("H inference", hInf, bn.inferenceOnNode(bnnH));
		}

		// lets make an observation and see its effect
		{
			bnnF.makeObservation("true");
			checkIfTrue(bnnF.getObservation().equals("true"), 0, "getobsrvation()");

			double[] fInf=  {1.0, 0.0};
			double[] lInf = {0.6, 0.4};
			double[] bInf = {0.01, 0.99};
			double[] dInf = {0.9009, 0.09910000000000001};
			double[] hInf = {0.631621, 0.368379};

			testDoubleArray("F inference", fInf, bn.inferenceOnNode(bnnF));
			testDoubleArray("L inference", lInf, bn.inferenceOnNode(bnnL));
			testDoubleArray("B inference", bInf, bn.inferenceOnNode(bnnB));
			testDoubleArray("D inference", dInf, bn.inferenceOnNode(bnnD));
			testDoubleArray("H inference", hInf, bn.inferenceOnNode(bnnH));
		}

	    // lets make an observation and see its effect
		{
			bnnF.clearObservation();
			checkIfTrue((bnnF.getObservation() == null), 1, "getObservaton()");
			bnnH.makeObservation("false");

			double[] fInf=  {0.07707992706701691, 0.9229200729329831};
			double[] lInf = {0.09239395988685929, 0.9076060401131407};
			double[] bInf = {0.004444693673519862, 0.9955553063264801};
			double[] dInf = {0.16564759408618462, 0.8343524059138154};
			double[] hInf = {0.0, 1.0};

			testDoubleArray("F inference", fInf, bn.inferenceOnNode(bnnF));
			testDoubleArray("L inference", lInf, bn.inferenceOnNode(bnnL));
			testDoubleArray("B inference", bInf, bn.inferenceOnNode(bnnB));
			testDoubleArray("D inference", dInf, bn.inferenceOnNode(bnnD));
			testDoubleArray("H inference", hInf, bn.inferenceOnNode(bnnH));
		}

		// multiple observations and see its effect
		{
			bnnL.makeObservation("true");
			bnnH.makeObservation("true");
			bnnB.makeObservation("true");

			double[] fInf=  {0.6836110981734096, 0.31638890182659035};
			double[] lInf = {1.0, 0.0};
			double[] bInf = {1.0, 0.0};
			double[] dInf = {0.9997616418765086, 2.38358123491426E-4};
			double[] hInf = {1.0, 0.0};

			testDoubleArray("F inference", fInf, bn.inferenceOnNode(bnnF));
			testDoubleArray("L inference", lInf, bn.inferenceOnNode(bnnL));
			testDoubleArray("B inference", bInf, bn.inferenceOnNode(bnnB));
			testDoubleArray("D inference", dInf, bn.inferenceOnNode(bnnD));
			testDoubleArray("H inference", hInf, bn.inferenceOnNode(bnnH));
		}

		// undo all observations and see if we are back to normal
		{
			bnnF.clearObservation();
			bnnH.clearObservation();
			bnnB.clearObservation();
			bnnL.clearObservation();
			bnnD.clearObservation();

			double[] fInf=  {0.15, 0.85};
			double[] lInf = {0.1325, 0.8674999999999999};
			double[] bInf = {0.01, 0.99};
			double[] dInf = {0.39582999999999996, 0.60417};
			double[] hInf = {0.2831227, 0.7168773};

			testDoubleArray("F inference", fInf, bn.inferenceOnNode(bnnF));
			testDoubleArray("L inference", lInf, bn.inferenceOnNode(bnnL));
			testDoubleArray("B inference", bInf, bn.inferenceOnNode(bnnB));
			testDoubleArray("D inference", dInf, bn.inferenceOnNode(bnnD));
			testDoubleArray("H inference", hInf, bn.inferenceOnNode(bnnH));
		}

		// remove a node an redo the inferences
		{
			bnnF.makeObservation("true");
			bn.removeNode(bnnF);

			double[] lInf = {0.5, 0.5};
			double[] bInf = {0.01, 0.99};
			double[] dInf = {0.5, 0.5};
			double[] hInf = {0.355, 0.645};

			testDoubleArray("L inference", lInf, bn.inferenceOnNode(bnnL));
			testDoubleArray("B inference", bInf, bn.inferenceOnNode(bnnB));
			testDoubleArray("D inference", dInf, bn.inferenceOnNode(bnnD));
			testDoubleArray("H inference", hInf, bn.inferenceOnNode(bnnH));
		}
	}
	catch(ProbabilityException e) {
		checkIfTrue(false, 1, "Prob exception for legal operations");
	}
	catch(InvalidValueException e) {
		checkIfTrue(false, 1, "Invalid value exception for legal operations");
	}				
	catch(InvalidArcException e) {
		checkIfTrue(false, 1, "InvalidArc exception for legal operations");
	}
}

public static void testDoubleArray(String output, double[] dArray1, double[] dArray2) {
	if (dArray1.length != dArray2.length) {
		System.out.println("***Failure " + output + " incorrect sized array");
		return;
	}

	boolean bFail = false;
	for(int x = 0; x < dArray1.length; x++) {
		if (java.lang.Math.abs(dArray1[x]- dArray2[x]) > 0.001) {
			System.out.println("***Failure " + output + " mismatched elements: " + x + " " + dArray1[x] +
				" " + dArray2[x]);
			bFail = true;
		}
	}

	if (!bFail)
		System.out.println(output + ": ok");
}




public static void testBnnEnumeration(int n, String output, Enumeration enum, String testString) {
	// requires: String testString is of form "ID1 ID2 ..." where each entry
	//           is the ID of a BayesNetworkNode object.  none of the strings or the enum can be null
    // effects: tests the enum of BayesNetworkNode returns what's in testString

	boolean testPassed = true;
	boolean bVerbose = false;

	if (bVerbose)
		System.out.println("Test string is " + testString);

	StringTokenizer st = new StringTokenizer(testString);
    Vector viBNN = new Vector();
    while(st.hasMoreElements()) {
		
		try {
			String s;
			viBNN.addElement(new Integer(s = (String)st.nextElement()));
			if (bVerbose)
				System.out.println("Adding to collection " + s);
		}
		catch(NumberFormatException e) {
			System.out.println("*****************Malformed interger in testBNNEnumeration");
		}
	}

	int iNumBNN = 0;
	while (enum.hasMoreElements()) {
		iNumBNN++;
		int iID = ((BayesNetworkNode)enum.nextElement()).getUniqueID();
		if (bVerbose)
			System.out.println("Enumeration returned " + iID);
		if (!viBNN.contains(new Integer(iID))) {
			System.out.println("***Failure " + n + " " + output + " : " + iID + " not found");
			testPassed = false;
		}
	}

	if (iNumBNN != viBNN.size()) {
		System.out.println("***Failure " + n + " " + output + " : enumeration size was wrong.  expected " +
			viBNN.size() + " but instead saw " + iNumBNN);
		testPassed = false;
	}
	
	
	if (testPassed)
		System.out.println(n + ": " + output + " : ok");
}

public static void compareBayesNodes(int n, String output, BayesNetworkNode bnn, String[] values, double[] probs) {
	String[] nodeValues = bnn.getValues();
	double[] nodeProbs = null;
	try {
		nodeProbs = bnn.getProb(null, null);
	}
	catch(ProbabilityException e) {
		checkIfTrue(false, n, output + ": Couldn't get probs");
		return;
	}
	catch(InvalidValueException e) {
		checkIfTrue(false, n, output + ": Couldn't get probs");
	}

	// now lets compare the values
	if (nodeValues.length != values.length) {
		checkIfTrue(false, n, output + " length of values unequal");
		return;
	}

	for(int i=0; i < nodeValues.length; i++)
		checkIfTrue(nodeValues[i].equals(values[i]), n, output + " comparing values " + i);

	if (nodeProbs.length != probs.length) {
		checkIfTrue(false, n, output + " length of probs unequal");
		return;
	}

	for(int i=0; i < nodeProbs.length; i++)
		checkIfTrue((nodeProbs[i] == probs[i]), n, output + " comparing probs " + i);
}



public static void checkIfTrue(boolean bCheck, int n, String output) {
	if (bCheck)
		System.out.println(n + ": " + output + " : ok");
	else
		System.out.println("*** Failure *** " + n + ": " + output);
}


} // test Class
